#include "amxxmodule.h"
#include "capsule.h"
#include <string.h>

// Rukia: Any class is a new addition; it can store ONE of ANYTHING.
//	HACK HACK HACK: any class isn't done; use capsule as a stop gap.

// Any:any_create(Any:copy = 0, static = 0)
static cell AMX_NATIVE_CALL	any_create(AMX *amx,cell *params)
{
	Capsule* tmp;

	// Rukia: Copy another any if necessary.
	if(params[2] == 1) { static Capsule tty; tmp = &tty; }
	else { tmp = New< Capsule, Mallocator >(); }

	if(params[1] != 0)
	{
		Capsule* tty = reinterpret_cast< Capsule * >(params[1]);
		*tmp = *tty;
	}

	return reinterpret_cast<cell>(tmp);
}

// void any_copy(Any:designation,Any:source)
static cell AMX_NATIVE_CALL	any_copy(AMX *amx,cell *params)
{
	Capsule* dsg = reinterpret_cast<Capsule*>(params[1]);
	Capsule* src = reinterpret_cast<Capsule*>(params[2]);

	*dsg = *src;
	return 1;
}

// void any_comp(Any:designation,Any:source)
static cell AMX_NATIVE_CALL	any_comp(AMX *amx,cell *params)
{
	Capsule* dsg = reinterpret_cast<Capsule*>(params[1]);
	Capsule* src = reinterpret_cast<Capsule*>(params[2]);

	return (*dsg) == (*src);
}

// void any_lex(Any:designation,Any:source)
static cell AMX_NATIVE_CALL	any_lex(AMX *amx,cell *params)
{
	Capsule* dsg = reinterpret_cast<Capsule*>(params[1]);
	Capsule* src = reinterpret_cast<Capsule*>(params[2]);

	return (*dsg) < (*src);
}

// Any:any_destroy(Any:me)
static cell AMX_NATIVE_CALL	any_destroy(AMX *amx,cell *params)
{
	Delete<Capsule, Mallocator >(reinterpret_cast<Capsule*>(params[1]),1);

	return 1;
}

// void any_clear(Any:me)
static cell AMX_NATIVE_CALL	any_clear(AMX *amx,cell *params)
{
	reinterpret_cast<Capsule*>(params[1])->clear();

	return 1;
}

// bool:any_empty(Any:me)
static cell AMX_NATIVE_CALL	any_empty(AMX *amx,cell *params)
{
	return static_cast<cell>(reinterpret_cast<Capsule*>(params[1])->empty() );
}

// any_type(Any:me)
static cell AMX_NATIVE_CALL	any_type(AMX *amx,cell *params)
{
	return static_cast<cell>(reinterpret_cast<Capsule*>(params[1])->getType() );
}

// any_set_none(Any:me)
static cell AMX_NATIVE_CALL	any_set_none(AMX *amx,cell *params)
{
	reinterpret_cast<Capsule*>(params[1])->setnone();
	return 1;
}

// any_get_raw(Any:me)
static cell AMX_NATIVE_CALL	any_get_raw(AMX *amx,cell *params)
{
	return reinterpret_cast<cell>(reinterpret_cast<Capsule*>(params[1])->getData() );
}

// any_set_bool(Any:me,bool:newval)
static cell AMX_NATIVE_CALL	any_set_bool(AMX *amx,cell *params)
{
	reinterpret_cast<Capsule*>(params[1])->setbool((params[2] == 1));
	return 1;
}

// bool:any_get_bool(Any:me,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	any_get_bool(AMX *amx,cell *params)
{
	bool* tmp = reinterpret_cast<Capsule*>(params[1])->getbool();
	if( (tmp == NULL) )
	{
		if(params[2] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve boolean from non-boolean ANY class"); }
		return -1;
	}
	return static_cast<cell>(*tmp);
}

// any_set_int(Any:me,cell:newval)
static cell AMX_NATIVE_CALL	any_set_int(AMX *amx,cell *params)
{
	reinterpret_cast<Capsule*>(params[1])->setint(params[2]);
	return 1;
}

// cell:any_get_int(Any:me,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	any_get_int(AMX *amx,cell *params)
{
	cell* tmp = reinterpret_cast<Capsule*>(params[1])->getint();
	if( (tmp == NULL) )
	{
		if(params[2] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve integer from non-integer ANY class"); }
		return -1;
	}
	return *tmp;
}

// any_set_ptr(Any:me,Ptr:newval)
static cell AMX_NATIVE_CALL	any_set_ptr(AMX *amx,cell *params)
{
	reinterpret_cast<Capsule*>(params[1])->setpointer(reinterpret_cast<void*>(params[2]));
	return 1;
}

// Ptr:any_get_ptr(Any:me,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	any_get_ptr(AMX *amx,cell *params)
{
	void* tmp = reinterpret_cast<Capsule*>(params[1])->getpointer();
	if( (tmp == NULL) )
	{
		if(params[2] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve pointer from non-pointer ANY class"); }
		return -1;
	}
	return reinterpret_cast<cell>(tmp);
}

// any_set_float(Any:me,Float:newval)
static cell AMX_NATIVE_CALL	any_set_float(AMX *amx,cell *params)
{
	reinterpret_cast<Capsule*>(params[1])->setfloat(amx_ctof(params[2]));
	return 1;
}

// Float:any_get_float(Any:me,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	any_get_float(AMX *amx,cell *params)
{
	REAL* tmp = reinterpret_cast<Capsule*>(params[1])->getfloat();
	if( (tmp == NULL) )
	{
		if(params[2] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve float from non-float ANY class"); }
		return -1;
	}
	return amx_ftoc(*tmp);
}

// any_set_vector(Any:me,Float:newval[3])
static cell AMX_NATIVE_CALL	any_set_vector(AMX *amx,cell *params)
{
	cell* ptr = MF_GetAmxAddr(amx,params[2]);
	HLVector tmp(amx_ctof(ptr[0]),amx_ctof(ptr[1]),amx_ctof(ptr[2]) );

	reinterpret_cast<Capsule*>(params[1])->setvector(tmp);
	return 1;
}

// any_get_vector(Any:me,Float:vec[3],no_fatal_errors=0)
static cell AMX_NATIVE_CALL	any_get_vector(AMX *amx,cell *params)
{
	HLVector* tmp = reinterpret_cast<Capsule*>(params[1])->getvector();
	if( (tmp == NULL) )
	{
		if(params[3] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve vector from non-vector ANY class"); }
		return -1;
	}
	cell* vec = MF_GetAmxAddr(amx,params[2]);

	vec[0] = amx_ftoc(tmp->x);
	vec[1] = amx_ftoc(tmp->y);
	vec[2] = amx_ftoc(tmp->z);

	return 1;
}

// any_set_array(Any:me,newval[],len)
static cell AMX_NATIVE_CALL	any_set_array(AMX *amx,cell *params)
{
	cell* ptr = MF_GetAmxAddr(amx,params[2]);
	vector<cell> tmp(ptr,params[3]);

	reinterpret_cast<Capsule*>(params[1])->setarray(tmp);
	return 1;
}


// any_get_array(Any:me,arr[],len,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	any_get_array(AMX *amx,cell *params)
{
	register vector<cell>* tmp = reinterpret_cast<Capsule*>(params[1])->getarray();
	if( (tmp == NULL) )
	{
		if(params[4] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve array from non-array ANY class"); }
		return -1;
	}
	register cell* arr = MF_GetAmxAddr(amx,params[2]);
	register size_t len = (static_cast<ucell>(params[3]) < tmp->size()) ? (params[3]) : (tmp->size());
	for(register size_t i = 0; i < len; i++)
	{
		arr[i] = (*tmp)[i];
	}

	return len;
}

// any_set_string(Any:me,newval[])
static cell AMX_NATIVE_CALL	any_set_string(AMX *amx,cell *params)
{
	int iLen;
	char* ptr = MF_GetAmxString(amx,params[2],0,&iLen);
	String tmp(ptr,iLen);

	reinterpret_cast<Capsule*>(params[1])->setstring(tmp);
	return 1;
}


// any_get_string(Any:me,arr[],len,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	any_get_string(AMX *amx,cell *params)
{
	register String* tmp = reinterpret_cast<Capsule*>(params[1])->getstring();
	if( (tmp == NULL) )
	{
		if(params[4] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve string from non-string ANY class"); }
		return -1;
	}

	return MF_SetAmxString(amx,params[2],tmp->c_str(),params[3]);
}

AMX_NATIVE_INFO any_Natives[] =
{
	{"any_create",		any_create},
	{"any_destroy",		any_destroy},

	{"any_clear",		any_clear},
	{"any_copy",		any_copy},

	{"any_empty",		any_empty},
	{"any_type",		any_type},

	{"any_set_none",		any_set_none},
	{"any_get_raw",		any_get_raw},

	{"any_set_bool",		any_set_bool},
	{"any_get_bool",	any_get_bool},

	{"any_set_int",		any_set_int},
	{"any_get_int",		any_get_int},

	{"any_set_ptr",		any_set_ptr},
	{"any_get_ptr",		any_get_ptr},

	{"any_set_float",		any_set_float},
	{"any_get_float",		any_get_float},

	{"any_set_vector",		any_set_vector},
	{"any_get_vector",		any_get_vector},

	{"any_set_array",		any_set_array},
	{"any_get_array",		any_get_array},

	{"any_set_string",		any_set_string},
	{"any_get_string",		any_get_string},

//	{"any_set_custom",		any_set_custom},
//	{"any_get_custom",		any_get_custom},

	{ NULL,				NULL}
};