#ifndef __CAPSULE_X__
#define __CAPSULE_X__

// Rukia: Capsule is a simple class that encapsulates PAWN types.
//	It is no where near as powerful as my any class, but any and rtti are no where near completed.
//	Conceptually, this is really just a simple container; a single layer of indirection if you will.
//	However, it is better than a hack of a pair.

// Rukia: Instead of the stupid layers and stuff I put in before, this is just going to be a simple container.
//	Unfortunately, its an ugly hack, but the true solution is just a bigger uglier hack anyway.

#include "alloc.h"
#include "vector"
#include "string"
#include "pair"
#include "amxxmodule.h"
#include "HLVector.h"

template <typename Alloc = MAlloc<char> >
class capsule
{
private:
	void* data;
	size_t type;

public:
	enum { CAPSULE_TYPE_NONE = 0, CAPSULE_TYPE_BOOL, CAPSULE_TYPE_INT, CAPSULE_TYPE_FLOAT, 
		CAPSULE_TYPE_VECTOR, CAPSULE_TYPE_ARRAY, CAPSULE_TYPE_STRING,
			CAPSULE_TYPE_POINTER, CAPSULE_TYPE_CUSTOM };

	capsule() : data(NULL), type(CAPSULE_TYPE_NONE)
	{ }

	capsule(const capsule& cpy)
		{ copy(cpy.data,cpy.type); }

	capsule& operator=(const capsule& cpy)
		{ copy(cpy.data,cpy.type); return *this; }

	~capsule()
		{ clear(); }

	void clear()
	{
		switch(type)
		{
			case CAPSULE_TYPE_NONE:
			case CAPSULE_TYPE_BOOL:
			case CAPSULE_TYPE_INT:
			case CAPSULE_TYPE_POINTER:
			case CAPSULE_TYPE_CUSTOM:
			case CAPSULE_TYPE_FLOAT:	{ type = CAPSULE_TYPE_NONE; data = NULL; break; }
			case CAPSULE_TYPE_VECTOR:	{ delete reinterpret_cast<HLVector*>(data); break; }
			case CAPSULE_TYPE_ARRAY:	{ delete reinterpret_cast<vector<cell>* >(data); break; }
			case CAPSULE_TYPE_STRING:	{ delete reinterpret_cast<String*>(data); break; }
			default:					{ type = CAPSULE_TYPE_NONE; data = NULL; break; }
		}
		type = 0; data = NULL;
	}

bool operator<(const capsule& two) const
{
	if(getType() != two.getType()) { return getType() < two.getType(); }

	switch(getType())
	{
		case CAPSULE_TYPE_NONE: { return false; }
		case CAPSULE_TYPE_BOOL: 
			{ return reinterpret_cast<cell>(getData()) < reinterpret_cast<cell>( two.getData() ); } 
		case CAPSULE_TYPE_INT: 
			{ return reinterpret_cast<cell>(getData()) < reinterpret_cast<cell>(two.getData()); }
		case CAPSULE_TYPE_POINTER: 
			{ return reinterpret_cast<cell>(getData()) < reinterpret_cast<cell>(two.getData()); }
		case CAPSULE_TYPE_CUSTOM: 
			{ return reinterpret_cast<cell>(getData()) < reinterpret_cast<cell>(two.getData()); }
		case CAPSULE_TYPE_FLOAT:	
			{ return amx_ctof(reinterpret_cast<cell>(getData())) < amx_ctof(reinterpret_cast<cell>(two.getData()) ); }
		case CAPSULE_TYPE_VECTOR:	
			{ return *reinterpret_cast<HLVector*>(getData()) < *reinterpret_cast<HLVector*>(two.getData()); }
		case CAPSULE_TYPE_ARRAY:	
			{ return *reinterpret_cast<vector<cell>*>(getData()) < *reinterpret_cast<vector<cell>*>(two.getData()); }
		case CAPSULE_TYPE_STRING:	
			{ return *reinterpret_cast<String*>(getData()) < *reinterpret_cast<String*>(two.getData()); }
	}

	return false;
}

bool operator==(const capsule& two) const
	{
		if(getType() != two.getType()) { return false; }

		switch(getType())
		{
		case CAPSULE_TYPE_NONE: { return false; }
		case CAPSULE_TYPE_BOOL: 
			{ return reinterpret_cast<cell>(getData()) == reinterpret_cast<cell>(two.getData()); }
		case CAPSULE_TYPE_INT: 
			{ return reinterpret_cast<cell>(getData()) == reinterpret_cast<cell>(two.getData()); }
		case CAPSULE_TYPE_POINTER: 
			{ return reinterpret_cast<cell>(getData()) == reinterpret_cast<cell>(two.getData()); }
		case CAPSULE_TYPE_CUSTOM: 
			{ return reinterpret_cast<cell>(getData()) == reinterpret_cast<cell>(two.getData()); }
		case CAPSULE_TYPE_FLOAT:	
			{ return amx_ctof(reinterpret_cast<cell>(getData())) == amx_ctof(reinterpret_cast<cell>(two.getData()) ); }
		case CAPSULE_TYPE_VECTOR:	
			{ return *reinterpret_cast<HLVector*>(getData()) == *reinterpret_cast<HLVector*>(two.getData()); }
		case CAPSULE_TYPE_ARRAY:	
			{ return *reinterpret_cast<vector<cell>*>(getData()) == *reinterpret_cast<vector<cell>*>(two.getData()); }
		case CAPSULE_TYPE_STRING:	
			{ return *reinterpret_cast<String*>(getData()) == *reinterpret_cast<String*>(two.getData()); }
		}
		return false;
	}


	bool empty()
		{ return data == NULL; }

	bool check(size_t typ)
		{ return (type == typ); }

	void* getData( void ) const			{ return data; }
	size_t getType( void ) const		{ return type; }

	void copy(void* dt, size_t tag)
	{
		clear();
		switch(tag)
		{
			case CAPSULE_TYPE_NONE:
			case CAPSULE_TYPE_BOOL:
			case CAPSULE_TYPE_INT:
			case CAPSULE_TYPE_POINTER:
			case CAPSULE_TYPE_CUSTOM:
			case CAPSULE_TYPE_FLOAT:	{ type = tag; data = dt; break; }
			case CAPSULE_TYPE_VECTOR:	{ setvector(*reinterpret_cast<HLVector*>(dt)); break; }
			case CAPSULE_TYPE_ARRAY:	{ setarray(*reinterpret_cast<vector<cell>* >(data)); break; }
			case CAPSULE_TYPE_STRING:	{ setstring(*reinterpret_cast<String*>(data)); break; }
			default:					{ type = 0; data = NULL; break; }
		}
	}

	void setnone()
		{ clear(); }

	void setnull()
		{ clear(); }

	void setbool(bool tty)
	{
		clear();
		data = reinterpret_cast<void*>( (tty) ? 1 : 0 );
		type = CAPSULE_TYPE_BOOL;
	}

	bool* getbool()
	{
		if(!check(CAPSULE_TYPE_BOOL)) { return NULL; };
		return reinterpret_cast<bool*>(&data);
	}

	void setint(cell tty)
	{
		clear();
		data = reinterpret_cast<void*>(tty);
		type = CAPSULE_TYPE_INT;
	}

	cell* getint()
	{
		if(!check(CAPSULE_TYPE_INT)) { return NULL; };
		return reinterpret_cast<cell*>(&data);
	}

	void setfloat(REAL tty)
	{
		clear();
		data = reinterpret_cast<void*>( amx_ftoc(tty) );
		type = CAPSULE_TYPE_FLOAT;
	}

	REAL* getfloat()
	{
		if(!check(CAPSULE_TYPE_FLOAT)) { return NULL; };
		return reinterpret_cast<REAL*>(&data);
	}

	void setvector(HLVector& tty)
	{
		clear();
		HLVector* tmp = New<HLVector,Alloc>(1,tty);
		data = reinterpret_cast<void*>(tmp);
		type = CAPSULE_TYPE_VECTOR;
	}

	HLVector* getvector()
	{
		if(!check(CAPSULE_TYPE_VECTOR)) { return NULL; };
		return reinterpret_cast<HLVector*>(data);
	}

	void setarray(vector<cell>& tty)
	{
		clear();
		vector<cell>* tmp = New<vector<cell>,Alloc>(1,tty);
		data = reinterpret_cast<void*>(tmp);
		type = CAPSULE_TYPE_ARRAY;
	}

	vector<cell>* getarray()
	{
		if(!check(CAPSULE_TYPE_ARRAY)) { return NULL; };
		return reinterpret_cast<vector<cell>*>(data);
	}

	void setstring(String& tty)
	{
		clear();
		String* tmp = New<String,Alloc>(1,tty);
		data = reinterpret_cast<void*>(tmp);
		type = CAPSULE_TYPE_STRING;
	}

	String* getstring()
	{
		if(!check(CAPSULE_TYPE_STRING)) { return NULL; };
		return reinterpret_cast<String*>(data);
	}

	void setpointer(void* tty)
	{
		data = tty;
		type = CAPSULE_TYPE_POINTER;
	}

	void* getpointer()
	{
		if(!check(CAPSULE_TYPE_POINTER)) { return NULL; };
		return (data);
	}

	void setcustom(pair<cell,void*>& tty)
	{
		clear();
		HLVector* tmp = New< pair<cell,void*> ,Alloc>(1,tty);
		data = reinterpret_cast<void*>(tmp);
		type = CAPSULE_TYPE_CUSTOM;
	}

	pair<cell,void*>* getcustom()
	{
		if(!check(CAPSULE_TYPE_CUSTOM)) { return NULL; };
		return reinterpret_cast< pair<cell,void*>* >(data);
	}
	
};

template <  typename Alloc> inline bool operator != (const capsule<Alloc>& a, const capsule<Alloc>& b)
	{ return !(a == b); }

template <  typename Alloc> inline bool operator > (const capsule<Alloc>& a, const capsule<Alloc>& b)
	{ return (b < a); }

template <  typename Alloc> inline bool operator >= (const capsule<Alloc>& a, const capsule<Alloc>& b)
	{ return !(a < b); }

template <  typename Alloc> inline bool operator <= (const capsule<Alloc>& a, const capsule<Alloc>& b)
	{ return !(b < a); }



typedef capsule<> Capsule;

// Rukia: HACK HACK HACK: This is so I can easily sub in the any class when it is done.
typedef Capsule any;

#endif
