#include "amxxmodule.h"
#include "deque"
#include "capsule.h"
#include "pawn_iterator.h"

// Rukia: deques last; iterators to deal with, complex interface.

typedef deque<Capsule> any_deque;

void* deque_iterator_func(PIterator* iter, size_t op, void* ptr)
{
	register any_deque::iterator* tmp = reinterpret_cast<any_deque::iterator*>(iter->iteratorptr);
	switch(op)
	{
		// (void) (NULL,NULL)
	case PIterator::ITERATOR_OP_CONSTRUCT: return reinterpret_cast<void*>(New<any_deque::iterator,Mallocator>() );
	// (NULL) (void*,NULL)
	case PIterator::ITERATOR_OP_COPY: 
		{
				register any_deque::iterator* tmp2 = (any_deque::iterator*)((PIterator*)ptr);
				*tmp = *tmp2;
				break;
		}
	//(void) (this,NULL)
	case PIterator::ITERATOR_OP_DECONSTRUCT: Delete<any_deque::iterator,Mallocator>((any_deque::iterator*)ptr,1); return NULL;

	// (void) (this,amount)
	case PIterator::ITERATOR_OP_PREFIX_ADD:
		{ *tmp += (size_t)ptr; break; }
	// (void) (this,amount)
	case PIterator::ITERATOR_OP_PREFIX_SUB:
		{ *tmp -= (size_t)ptr; break; }

	// (void*) (this,amount)
	//PIterator::ITERATOR_OP_POSTFIX_ADD:
	// (void*) (this,amount)
	//PIterator::ITERATOR_OP_POSTFIX_SUB:

	// (bool) (this,other)
	case PIterator::ITERATOR_OP_EQUALTO:
		{
				register any_deque::iterator* tmp2 = (any_deque::iterator*)((PIterator*)ptr);
				return (*tmp == *tmp2) ? (void*)1 : (void*)2;
		}
		
	// (bool) (this,other)
	case PIterator::ITERATOR_OP_LESSTHAN: 
		{
				register any_deque::iterator* tmp2 = (any_deque::iterator*)((PIterator*)ptr);
				return (*tmp < *tmp2) ? (void*)1 : (void*)2;
		}

	// (Capsule*) (this,NULL)
	case PIterator::ITERATOR_OP_DEREFERENCE:
		{
				static Capsule& tty = *(*tmp);
				return static_cast<void*>( &tty );
		}
	// (Capsule*) (this,NULL)
	case PIterator::ITERATOR_OP_KEY:
		{
			return (void*)NULL;
		}
	}
	return (void*)NULL;
}

// void Iterator:deque_begin(Deque:designation,static = 0)
static cell AMX_NATIVE_CALL	deque_begin(AMX *amx,cell *params)
{
	any_iterator* tmp;
	if(params[2] == 1)
	{
		static any_iterator tty(deque_iterator_func);  
		tmp = &tty;
	}
	else tmp = New<any_iterator,Mallocator>(1,any_iterator(deque_iterator_func) );

	tmp->set(reinterpret_cast<any_deque*>(params[1])->begin());
	return reinterpret_cast<cell>(tmp);
}

// void Iterator:deque_end(Deque:designation,static = 0)
static cell AMX_NATIVE_CALL	deque_end(AMX *amx,cell *params)
{
	any_iterator* tmp;
	if(params[2] == 1)
	{
		static any_iterator tty(deque_iterator_func);  
		tmp = &tty;
	}
	else tmp = New<any_iterator,Mallocator>(1,any_iterator(deque_iterator_func) );

	tmp->set(reinterpret_cast<any_deque*>(params[1])->end());
	return reinterpret_cast<cell>(tmp);
}

// void Iterator:deque_at(Deque:designation,slot, static = 0)
static cell AMX_NATIVE_CALL	deque_at(AMX *amx,cell *params)
{
	any_iterator* tmp;
	if(params[3] == 1)
	{
		static any_iterator tty(deque_iterator_func);  
		tmp = &tty;
	}
	else tmp = New<any_iterator,Mallocator>(1,any_iterator(deque_iterator_func) );

	tmp->set(reinterpret_cast<any_deque*>(params[1])->iterAt(params[2]));
	return reinterpret_cast<cell>(tmp);
}

void* deque_reverse_iterator_func(PIterator* iter, size_t op, void* ptr)
{
	register any_deque::reverse_iterator* tmp = reinterpret_cast<any_deque::reverse_iterator*>(iter->iteratorptr);
	switch(op)
	{
		// (void) (NULL,NULL)
	case PIterator::ITERATOR_OP_CONSTRUCT: return reinterpret_cast<void*>(New<any_deque::reverse_iterator,Mallocator>() );
	// (NULL) (void*,NULL)
	case PIterator::ITERATOR_OP_COPY: 
		{
				register any_deque::reverse_iterator* tmp2 = (any_deque::reverse_iterator*)((PIterator*)ptr);
				*tmp = *tmp2;
				break;
		}
	//(void) (this,NULL)
	case PIterator::ITERATOR_OP_DECONSTRUCT: Delete<any_deque::reverse_iterator,Mallocator>((any_deque::reverse_iterator*)ptr,1); return NULL;

	// (void) (this,amount)
	case PIterator::ITERATOR_OP_PREFIX_ADD:
		{ *tmp += (size_t)ptr; break; }
	// (void) (this,amount)
	case PIterator::ITERATOR_OP_PREFIX_SUB:
		{ *tmp -= (size_t)ptr; break; }

	// (void*) (this,amount)
	//PIterator::ITERATOR_OP_POSTFIX_ADD:
	// (void*) (this,amount)
	//PIterator::ITERATOR_OP_POSTFIX_SUB:

	// (bool) (this,other)
	case PIterator::ITERATOR_OP_EQUALTO:
		{
				register any_deque::reverse_iterator* tmp2 = (any_deque::reverse_iterator*)((PIterator*)ptr);
				return (*tmp == *tmp2) ? (void*)1 : (void*)2;
		}
		
	// (bool) (this,other)
	case PIterator::ITERATOR_OP_LESSTHAN: 
		{
				register any_deque::reverse_iterator* tmp2 = (any_deque::reverse_iterator*)((PIterator*)ptr);
				return (*tmp < *tmp2) ? (void*)1 : (void*)2;
		}

	// (Capsule*) (this,NULL)
	case PIterator::ITERATOR_OP_DEREFERENCE:
		{
				static Capsule& tty = *(*tmp);
				return static_cast<void*>( &tty );
		}
	// (Capsule*) (this,NULL)
	case PIterator::ITERATOR_OP_KEY:
		{
			return (void*)NULL;
		}
	}
	return (void*)NULL;
}

// void Iterator:deque_rbegin(Deque:designation,static = 0)
static cell AMX_NATIVE_CALL	deque_rbegin(AMX *amx,cell *params)
{
	any_iterator* tmp;
	if(params[2] == 1)
	{
		static any_iterator tty(deque_reverse_iterator_func);  
		tmp = &tty;
	}
	else tmp = New<any_iterator,Mallocator>(1,any_iterator(deque_reverse_iterator_func) );

	tmp->set(reinterpret_cast<any_deque*>(params[1])->begin());
	return reinterpret_cast<cell>(tmp);
}

// void Iterator:deque_end(Deque:designation,static = 0)
static cell AMX_NATIVE_CALL	deque_rend(AMX *amx,cell *params)
{
	any_iterator* tmp;
	if(params[2] == 1)
	{
		static any_iterator tty(deque_reverse_iterator_func);  
		tmp = &tty;
	}
	else tmp = New<any_iterator,Mallocator>(1,any_iterator(deque_reverse_iterator_func) );

	tmp->set(reinterpret_cast<any_deque*>(params[1])->end());
	return reinterpret_cast<cell>(tmp);
}

// void Iterator:deque_rat(Deque:designation,slot, static = 0)
static cell AMX_NATIVE_CALL	deque_rat(AMX *amx,cell *params)
{
	any_iterator* tmp;
	if(params[3] == 1)
	{
		static any_iterator tty(deque_reverse_iterator_func);  
		tmp = &tty;
	}
	else tmp = New<any_iterator,Mallocator>(1,any_iterator(deque_reverse_iterator_func) );

	any_deque* tyt = reinterpret_cast<any_deque*>(params[1]);
	tmp->set(tyt->iterAt(tyt->size() - params[2]));
	return reinterpret_cast<cell>(tmp);
}

// Rukia: Here is our queue handler function.

// Deque:deque_create(Deque:copy = NULL, static = 0)
static cell AMX_NATIVE_CALL	deque_create(AMX *amx,cell *params)
{
	any_deque* tmp;

	// Rukia: Copy another deque if necessary.
	if(params[2] == 1) { static any_deque tty; tty.clear(); tmp = &tty; }
	else { tmp = New<any_deque, Mallocator >(); }

	if(params[1] != 0)
	{
		any_deque * tty = reinterpret_cast<any_deque * >(params[1]);
		*tmp = *tty;
	}

	return reinterpret_cast<cell>(tmp);
}

// void deque_copy(Deque:designation,Deque:source)
static cell AMX_NATIVE_CALL	deque_copy(AMX *amx,cell *params)
{
	any_deque* dsg = reinterpret_cast<any_deque*>(params[1]);
	any_deque* src = reinterpret_cast<any_deque*>(params[2]);

	*dsg = *src;
	return 1;
}

// void bool:deque_comp(Deque:designation,Deque:source)
static cell AMX_NATIVE_CALL	deque_comp(AMX *amx,cell *params)
{
	any_deque* dsg = reinterpret_cast<any_deque*>(params[1]);
	any_deque* src = reinterpret_cast<any_deque*>(params[2]);

	return (*dsg) == (*src);
}

// void bool:deque_lex(Deque:designation,Deque:source)
static cell AMX_NATIVE_CALL	deque_lex(AMX *amx,cell *params)
{
	any_deque* dsg = reinterpret_cast<any_deque*>(params[1]);
	any_deque* src = reinterpret_cast<any_deque*>(params[2]);

	return (*dsg) < (*src);
}

// Rukia: Not technically part of ANSI STL deques; it matches our standard API though.
// void deque_clear(Deque:me)
static cell AMX_NATIVE_CALL	deque_clear(AMX *amx,cell *params)
{
	reinterpret_cast<any_deque*>(params[1])->clear();

	return 1;
}

// Deque:deque_destroy(Deque:me)
static cell AMX_NATIVE_CALL	deque_destroy(AMX *amx,cell *params)
{
	Delete<any_deque, Mallocator >(reinterpret_cast<any_deque*>(params[1]),1);

	return 1;
}

// bool:deque_empty(Deque:me)
static cell AMX_NATIVE_CALL	deque_empty(AMX *amx,cell *params)
{
	return static_cast<cell>(reinterpret_cast<any_deque*>(params[1])->empty() );
}

// Rukia: Unfortunately, to get this out, I have to give up finishing the allocator for a while.
//	Returns the amount of space wasted but not the exact total memory used.

// cell deque_memory(Deque:me)
static cell AMX_NATIVE_CALL	deque_memory(AMX *amx,cell *params)
{
	return static_cast<cell>(reinterpret_cast<any_deque*>(params[1])->size() * sizeof(Capsule) );
}

// cell deque_size(Deque:me)
static cell AMX_NATIVE_CALL	deque_size(AMX *amx,cell *params)
{
	return static_cast<cell>(reinterpret_cast<any_deque*>(params[1])->size() );
}

// deque_pop_back(Deque:me)
static cell AMX_NATIVE_CALL	deque_pop_back(AMX *amx,cell *params)
{
	reinterpret_cast<any_deque*>(params[1])->pop_back();
	return 1;
}

// deque_pop_front(Deque:me)
static cell AMX_NATIVE_CALL	deque_pop_front(AMX *amx,cell *params)
{
	reinterpret_cast<any_deque*>(params[1])->pop_front();
	return 1;
}

// Any:deque_front(Deque:me)
static cell AMX_NATIVE_CALL	deque_front(AMX *amx,cell *params)
{
	return reinterpret_cast<cell>(&reinterpret_cast<any_deque*>(params[1])->front() );
}

// deque_front_raw(Deque:me)
static cell AMX_NATIVE_CALL	deque_front_raw(AMX *amx,cell *params)
{
	any_deque* tmp_deque = reinterpret_cast<any_deque*>(params[1]);
	
	return reinterpret_cast<cell>(tmp_deque->front().getData() );
}

// bool:deque_front_bool(Deque:me,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	deque_front_bool(AMX *amx,cell *params)
{
	any_deque* tmp_deque = reinterpret_cast<any_deque*>(params[1]);
	bool* tmp = tmp_deque->front().getbool();

	if( (tmp == NULL) )
	{
		if(params[2] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve boolean from non-boolean ANY class"); }
		return -1;
	}
	return static_cast<cell>(*tmp);
}

// cell:deque_front_int(Deque:me,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	deque_front_int(AMX *amx,cell *params)
{
	any_deque* tmp_deque = reinterpret_cast<any_deque*>(params[1]);
	cell* tmp = tmp_deque->front().getint();

	if( (tmp == NULL) )
	{
		if(params[2] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve integer from non-integer ANY class"); }
		return -1;
	}
	return *tmp;
}

// Ptr:deque_front_ptr(Deque:me,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	deque_front_ptr(AMX *amx,cell *params)
{
	any_deque* tmp_deque = reinterpret_cast<any_deque*>(params[1]);
	void* tmp = tmp_deque->front().getpointer();

	if( (tmp == NULL) )
	{
		if(params[2] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve pointer from non-pointer ANY class"); }
		return -1;
	}
	return reinterpret_cast<cell>(tmp);
}

// Float:deque_front_float(Deque:me,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	deque_front_float(AMX *amx,cell *params)
{
	any_deque* tmp_deque = reinterpret_cast<any_deque*>(params[1]);
	REAL* tmp = tmp_deque->front().getfloat();

	if( (tmp == NULL) )
	{
		if(params[2] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve float from non-float ANY class"); }
		return -1;
	}
	return amx_ftoc(*tmp);
}

// deque_front_deque(Deque:me,Float:vec[3],no_fatal_errors=0)
static cell AMX_NATIVE_CALL	deque_front_deque(AMX *amx,cell *params)
{
	any_deque* tmp_deque = reinterpret_cast<any_deque*>(params[1]);
	HLVector* tmp = tmp_deque->front().getvector();

	if( (tmp == NULL) )
	{
		if(params[3] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve deque from non-deque ANY class"); }
		return -1;
	}
	cell* vec = MF_GetAmxAddr(amx,params[2]);

	vec[0] = amx_ftoc(tmp->x);
	vec[1] = amx_ftoc(tmp->y);
	vec[2] = amx_ftoc(tmp->z);

	return 1;
}

// deque_front_array(Deque:me,arr[],len,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	deque_front_array(AMX *amx,cell *params)
{
	any_deque* tmp_deque = reinterpret_cast<any_deque*>(params[1]);
	register vector<cell>* tmp = tmp_deque->front().getarray();

	if( (tmp == NULL) )
	{
		if(params[4] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve array from non-array ANY class"); }
		return -1;
	}
	register cell* arr = MF_GetAmxAddr(amx,params[2]);
	register size_t len = (static_cast<ucell>(params[3]) < tmp->size()) ? (params[3]) : (tmp->size());
	for(register size_t i = 0; i < len; i++)
	{
		arr[i] = (*tmp)[i];
	}

	return len;
}

// deque_front_string(Deque:me,arr[],len,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	deque_front_string(AMX *amx,cell *params)
{
	any_deque* tmp_deque = reinterpret_cast<any_deque*>(params[1]);
	register String* tmp = tmp_deque->front().getstring();

	if( (tmp == NULL) )
	{
		if(params[4] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve string from non-string ANY class"); }
		return -1;
	}

	return MF_SetAmxString(amx,params[2],tmp->c_str(),params[3]);
}

// Any:deque_back(Deque:me)
static cell AMX_NATIVE_CALL	deque_back(AMX *amx,cell *params)
{
	return reinterpret_cast<cell>(&reinterpret_cast<any_deque*>(params[1])->back() );
}

// deque_back_raw(Deque:me)
static cell AMX_NATIVE_CALL	deque_back_raw(AMX *amx,cell *params)
{
	any_deque* tmp_deque = reinterpret_cast<any_deque*>(params[1]);
	
	return reinterpret_cast<cell>(tmp_deque->back().getData() );
}

// bool:deque_back_bool(Deque:me,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	deque_back_bool(AMX *amx,cell *params)
{
	any_deque* tmp_deque = reinterpret_cast<any_deque*>(params[1]);
	bool* tmp = tmp_deque->back().getbool();

	if( (tmp == NULL) )
	{
		if(params[2] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve boolean from non-boolean ANY class"); }
		return -1;
	}
	return static_cast<cell>(*tmp);
}

// cell:deque_back_int(Deque:me,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	deque_back_int(AMX *amx,cell *params)
{
	any_deque* tmp_deque = reinterpret_cast<any_deque*>(params[1]);
	cell* tmp = tmp_deque->back().getint();

	if( (tmp == NULL) )
	{
		if(params[2] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve integer from non-integer ANY class"); }
		return -1;
	}
	return *tmp;
}

// Ptr:deque_back_ptr(Deque:me,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	deque_back_ptr(AMX *amx,cell *params)
{
	any_deque* tmp_deque = reinterpret_cast<any_deque*>(params[1]);
	void* tmp = tmp_deque->back().getpointer();

	if( (tmp == NULL) )
	{
		if(params[2] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve pointer from non-pointer ANY class"); }
		return -1;
	}
	return reinterpret_cast<cell>(tmp);
}

// Float:deque_back_float(Deque:me,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	deque_back_float(AMX *amx,cell *params)
{
	any_deque* tmp_deque = reinterpret_cast<any_deque*>(params[1]);
	REAL* tmp = tmp_deque->back().getfloat();

	if( (tmp == NULL) )
	{
		if(params[2] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve float from non-float ANY class"); }
		return -1;
	}
	return amx_ftoc(*tmp);
}

// deque_back_deque(Deque:me,Float:vec[3],no_fatal_errors=0)
static cell AMX_NATIVE_CALL	deque_back_deque(AMX *amx,cell *params)
{
	any_deque* tmp_deque = reinterpret_cast<any_deque*>(params[1]);
	HLVector* tmp = tmp_deque->back().getvector();

	if( (tmp == NULL) )
	{
		if(params[3] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve deque from non-deque ANY class"); }
		return -1;
	}
	cell* vec = MF_GetAmxAddr(amx,params[2]);

	vec[0] = amx_ftoc(tmp->x);
	vec[1] = amx_ftoc(tmp->y);
	vec[2] = amx_ftoc(tmp->z);

	return 1;
}

// deque_back_array(Deque:me,arr[],len,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	deque_back_array(AMX *amx,cell *params)
{
	any_deque* tmp_deque = reinterpret_cast<any_deque*>(params[1]);
	register vector<cell>* tmp = tmp_deque->back().getarray();

	if( (tmp == NULL) )
	{
		if(params[4] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve array from non-array ANY class"); }
		return -1;
	}
	register cell* arr = MF_GetAmxAddr(amx,params[2]);
	register size_t len = (static_cast<ucell>(params[3]) < tmp->size()) ? (params[3]) : (tmp->size());
	for(register size_t i = 0; i < len; i++)
	{
		arr[i] = (*tmp)[i];
	}

	return len;
}

// deque_back_string(Deque:me,arr[],len,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	deque_back_string(AMX *amx,cell *params)
{
	any_deque* tmp_deque = reinterpret_cast<any_deque*>(params[1]);
	register String* tmp = tmp_deque->back().getstring();

	if( (tmp == NULL) )
	{
		if(params[4] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve string from non-string ANY class"); }
		return -1;
	}

	return MF_SetAmxString(amx,params[2],tmp->c_str(),params[3]);
}

// Any:deque_get(Deque:me,slot)
static cell AMX_NATIVE_CALL	deque_get(AMX *amx,cell *params)
{
	any_deque* tmp_deque = reinterpret_cast<any_deque*>(params[1]);
	
	return reinterpret_cast<cell>( &((*tmp_deque)[params[2]]) );
}

// deque_get_raw(Deque:me,slot)
static cell AMX_NATIVE_CALL	deque_get_raw(AMX *amx,cell *params)
{
	any_deque* tmp_deque = reinterpret_cast<any_deque*>(params[1]);
	
	return reinterpret_cast<cell>((*tmp_deque)[params[2]].getData() );
}

// bool:deque_get_bool(Deque:me,slot,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	deque_get_bool(AMX *amx,cell *params)
{
	any_deque* tmp_deque = reinterpret_cast<any_deque*>(params[1]);
	bool* tmp = (*tmp_deque)[params[2]].getbool();

	if( (tmp == NULL) )
	{
		if(params[3] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve boolean from non-boolean ANY class"); }
		return -1;
	}
	return static_cast<cell>(*tmp);
}

// cell:deque_get_int(Deque:me,slot,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	deque_get_int(AMX *amx,cell *params)
{
	any_deque* tmp_deque = reinterpret_cast<any_deque*>(params[1]);
	cell* tmp = (*tmp_deque)[params[2]].getint();

	if( (tmp == NULL) )
	{
		if(params[3] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve integer from non-integer ANY class"); }
		return -1;
	}
	return *tmp;
}

// Ptr:deque_get_ptr(Deque:me,slot,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	deque_get_ptr(AMX *amx,cell *params)
{
	any_deque* tmp_deque = reinterpret_cast<any_deque*>(params[1]);
	void* tmp = (*tmp_deque)[params[2]].getpointer();

	if( (tmp == NULL) )
	{
		if(params[3] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve pointer from non-pointer ANY class"); }
		return -1;
	}
	return reinterpret_cast<cell>(tmp);
}

// Float:deque_get_float(Deque:me,slot,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	deque_get_float(AMX *amx,cell *params)
{
	any_deque* tmp_deque = reinterpret_cast<any_deque*>(params[1]);
	REAL* tmp = (*tmp_deque)[params[2]].getfloat();

	if( (tmp == NULL) )
	{
		if(params[3] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve float from non-float ANY class"); }
		return -1;
	}
	return amx_ftoc(*tmp);
}

// deque_get_deque(Deque:me,slot,Float:vec[3],no_fatal_errors=0)
static cell AMX_NATIVE_CALL	deque_get_deque(AMX *amx,cell *params)
{
	any_deque* tmp_deque = reinterpret_cast<any_deque*>(params[1]);
	HLVector* tmp = (*tmp_deque)[params[2]].getvector();

	if( (tmp == NULL) )
	{
		if(params[4] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve deque from non-deque ANY class"); }
		return -1;
	}
	cell* vec = MF_GetAmxAddr(amx,params[2]);

	vec[0] = amx_ftoc(tmp->x);
	vec[1] = amx_ftoc(tmp->y);
	vec[2] = amx_ftoc(tmp->z);

	return 1;
}

// deque_get_array(Deque:me,slot,arr[],len,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	deque_get_array(AMX *amx,cell *params)
{
	any_deque* tmp_deque = reinterpret_cast<any_deque*>(params[1]);
	register vector<cell>* tmp = (*tmp_deque)[params[2]].getarray();

	if( (tmp == NULL) )
	{
		if(params[5] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve array from non-array ANY class"); }
		return -1;
	}
	register cell* arr = MF_GetAmxAddr(amx,params[2]);
	register size_t len = (static_cast<ucell>(params[3]) < tmp->size()) ? (params[3]) : (tmp->size());
	for(register size_t i = 0; i < len; i++)
	{
		arr[i] = (*tmp)[i];
	}

	return len;
}

// deque_get_string(Deque:me,slot,arr[],len,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	deque_get_string(AMX *amx,cell *params)
{
	any_deque* tmp_deque = reinterpret_cast<any_deque*>(params[1]);
	register String* tmp = (*tmp_deque)[params[2]].getstring();

	if( (tmp == NULL) )
	{
		if(params[5] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve string from non-string ANY class"); }
		return -1;
	}

	return MF_SetAmxString(amx,params[2],tmp->c_str(),params[3]);
}


// deque_set(Deque:me,slot,Any:ptr)
static cell AMX_NATIVE_CALL	deque_set(AMX *amx,cell *params)
{
	Capsule* tmp = reinterpret_cast<Capsule*>(params[3]);
	(*reinterpret_cast<any_deque*>(params[1]))[params[2]] = *tmp;
	return 1;
}

// deque_set_none(Deque:me,slot)
static cell AMX_NATIVE_CALL	deque_set_none(AMX *amx,cell *params)
{
	Capsule tmp; tmp.setnone();
	(*reinterpret_cast<any_deque*>(params[1]))[params[2]] = tmp;
	return 1;
}

// deque_set_bool(Deque:me,slot,bool:newval)
static cell AMX_NATIVE_CALL	deque_set_bool(AMX *amx,cell *params)
{
	Capsule tmp; tmp.setbool((params[3] == 1));
	(*reinterpret_cast<any_deque*>(params[1]))[params[2]] = tmp;
	return 1;
}

// deque_set_int(Deque:me,slot,cell:newval)
static cell AMX_NATIVE_CALL	deque_set_int(AMX *amx,cell *params)
{
	Capsule tmp; tmp.setint(params[3]);
	(*reinterpret_cast<any_deque*>(params[1]))[params[2]] = tmp;
	return 1;
}

// deque_set_ptr(Deque:me,slot,Ptr:newval)
static cell AMX_NATIVE_CALL	deque_set_ptr(AMX *amx,cell *params)
{
	Capsule tmp; tmp.setpointer(reinterpret_cast<void*>(params[3]));
	(*reinterpret_cast<any_deque*>(params[1]))[params[2]] = tmp;
	return 1;
}

// deque_set_float(Deque:me,slot,Float:newval)
static cell AMX_NATIVE_CALL	deque_set_float(AMX *amx,cell *params)
{
	Capsule tmp; tmp.setfloat(amx_ctof(params[3]));
	(*reinterpret_cast<any_deque*>(params[1]))[params[2]] = tmp;
	return 1;
}

// deque_set_deque(Deque:me,slot,Float:newval[3])
static cell AMX_NATIVE_CALL	deque_set_deque(AMX *amx,cell *params)
{
	cell* ptr = MF_GetAmxAddr(amx,params[3]);
	HLVector tty(amx_ctof(ptr[0]),amx_ctof(ptr[1]),amx_ctof(ptr[2]));

	Capsule tmp; tmp.setvector(tty);
	(*reinterpret_cast<any_deque*>(params[1]))[params[2]] = tmp;
	return 1;
}

// deque_set_array(Deque:me,slot,newval[],len)
static cell AMX_NATIVE_CALL	deque_set_array(AMX *amx,cell *params)
{
	cell* ptr = MF_GetAmxAddr(amx,params[3]);
	vector<cell> tty(ptr,params[4]);

	Capsule tmp; tmp.setarray(tty);
	(*reinterpret_cast<any_deque*>(params[1]))[params[2]] = tmp;
	return 1;
}

// deque_set_string(Deque:me,slot,newval[])
static cell AMX_NATIVE_CALL	deque_set_string(AMX *amx,cell *params)
{
	int iLen;
	char* ptr = MF_GetAmxString(amx,params[3],0,&iLen);
	String tty(ptr,iLen);

	Capsule tmp; tmp.setstring(tty);
	(*reinterpret_cast<any_deque*>(params[1]))[params[2]] = tmp;
	return 1;
}

// deque_push_front(Deque:me,Any:add)
static cell AMX_NATIVE_CALL	deque_push_front(AMX *amx,cell *params)
{
	reinterpret_cast<any_deque*>(params[1])->
		push_front(*reinterpret_cast<Capsule*>(params[2]) );
	return 1;
}

// deque_push_front_none(Deque:me)
static cell AMX_NATIVE_CALL	deque_push_front_none(AMX *amx,cell *params)
{
	Capsule tmp; tmp.setnone();
	reinterpret_cast<any_deque*>(params[1])->push_front(tmp);
	return 1;
}

// deque_push_front_bool(Deque:me,bool:newval)
static cell AMX_NATIVE_CALL	deque_push_front_bool(AMX *amx,cell *params)
{
	Capsule tmp; tmp.setbool((params[2] == 1));
	reinterpret_cast<any_deque*>(params[1])->push_front(tmp);
	return 1;
}

// deque_push_front_int(Deque:me,cell:newval)
static cell AMX_NATIVE_CALL	deque_push_front_int(AMX *amx,cell *params)
{
	Capsule tmp; tmp.setint(params[2]);
	reinterpret_cast<any_deque*>(params[1])->push_front(tmp);
	return 1;
}

// deque_push_front_ptr(Deque:me,Ptr:newval)
static cell AMX_NATIVE_CALL	deque_push_front_ptr(AMX *amx,cell *params)
{
	Capsule tmp; tmp.setpointer(reinterpret_cast<void*>(params[2]));
	reinterpret_cast<any_deque*>(params[1])->push_front(tmp);
	return 1;
}

// deque_push_front_float(Deque:me,Float:newval)
static cell AMX_NATIVE_CALL	deque_push_front_float(AMX *amx,cell *params)
{
	Capsule tmp; tmp.setfloat(amx_ctof(params[2]));
	reinterpret_cast<any_deque*>(params[1])->push_front(tmp);
	return 1;
}

// deque_push_front_deque(Deque:me,Float:newval[3])
static cell AMX_NATIVE_CALL	deque_push_front_deque(AMX *amx,cell *params)
{
	cell* ptr = MF_GetAmxAddr(amx,params[2]);
	HLVector tty(amx_ctof(ptr[0]),amx_ctof(ptr[1]),amx_ctof(ptr[2]));

	Capsule tmp; tmp.setvector(tty);
	reinterpret_cast<any_deque*>(params[1])->push_front(tmp);
	return 1;
}

// deque_push_front_array(Deque:me,newval[],len)
static cell AMX_NATIVE_CALL	deque_push_front_array(AMX *amx,cell *params)
{
	cell* ptr = MF_GetAmxAddr(amx,params[2]);
	vector<cell> tty(ptr,params[3]);

	Capsule tmp; tmp.setarray(tty);
	reinterpret_cast<any_deque*>(params[1])->push_front(tmp);
	return 1;
}

// deque_push_front_string(Deque:me,newval[])
static cell AMX_NATIVE_CALL	deque_push_front_string(AMX *amx,cell *params)
{
	int iLen;
	char* ptr = MF_GetAmxString(amx,params[2],0,&iLen);
	String tty(ptr,iLen);

	Capsule tmp; tmp.setstring(tty);
	reinterpret_cast<any_deque*>(params[1])->push_front(tmp);
	return 1;
}

// Any:deque_peek_front(Deque:me)
static cell AMX_NATIVE_CALL	deque_peek_front(AMX *amx,cell *params)
{
	Capsule& tmp = reinterpret_cast<any_deque*>(params[1])->peek_front();
	return reinterpret_cast<cell>(&tmp);
}

// deque_peek_front_raw(Deque:me)
static cell AMX_NATIVE_CALL	deque_peek_front_raw(AMX *amx,cell *params)
{
	any_deque* tmp_deque = reinterpret_cast<any_deque*>(params[1]);
	
	return reinterpret_cast<cell>(tmp_deque->peek_front().getData() );
}

// bool:deque_peek_front_bool(Deque:me,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	deque_peek_front_bool(AMX *amx,cell *params)
{
	any_deque* tmp_deque = reinterpret_cast<any_deque*>(params[1]);
	bool* tmp = tmp_deque->peek_front().getbool();

	if( (tmp == NULL) )
	{
		if(params[2] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve boolean from non-boolean ANY class"); }
		return -1;
	}
	return static_cast<cell>(*tmp);
}

// cell:deque_peek_front_int(Deque:me,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	deque_peek_front_int(AMX *amx,cell *params)
{
	any_deque* tmp_deque = reinterpret_cast<any_deque*>(params[1]);
	cell* tmp = tmp_deque->peek_front().getint();

	if( (tmp == NULL) )
	{
		if(params[2] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve integer from non-integer ANY class"); }
		return -1;
	}
	return *tmp;
}

// Ptr:deque_peek_front_ptr(Deque:me,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	deque_peek_front_ptr(AMX *amx,cell *params)
{
	any_deque* tmp_deque = reinterpret_cast<any_deque*>(params[1]);
	void* tmp = tmp_deque->peek_front().getpointer();

	if( (tmp == NULL) )
	{
		if(params[2] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve pointer from non-pointer ANY class"); }
		return -1;
	}
	return reinterpret_cast<cell>(tmp);
}

// Float:deque_peek_front_float(Deque:me,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	deque_peek_front_float(AMX *amx,cell *params)
{
	any_deque* tmp_deque = reinterpret_cast<any_deque*>(params[1]);
	REAL* tmp = tmp_deque->peek_front().getfloat();

	if( (tmp == NULL) )
	{
		if(params[2] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve float from non-float ANY class"); }
		return -1;
	}
	return amx_ftoc(*tmp);
}

// deque_peek_front_deque(Deque:me,Float:vec[3],no_fatal_errors=0)
static cell AMX_NATIVE_CALL	deque_peek_front_deque(AMX *amx,cell *params)
{
	any_deque* tmp_deque = reinterpret_cast<any_deque*>(params[1]);
	HLVector* tmp = tmp_deque->peek_front().getvector();

	if( (tmp == NULL) )
	{
		if(params[3] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve deque from non-deque ANY class"); }
		return -1;
	}
	cell* vec = MF_GetAmxAddr(amx,params[2]);

	vec[0] = amx_ftoc(tmp->x);
	vec[1] = amx_ftoc(tmp->y);
	vec[2] = amx_ftoc(tmp->z);

	return 1;
}

// deque_peek_front_array(Deque:me,arr[],len,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	deque_peek_front_array(AMX *amx,cell *params)
{
	any_deque* tmp_deque = reinterpret_cast<any_deque*>(params[1]);
	register vector<cell>* tmp = tmp_deque->peek_front().getarray();

	if( (tmp == NULL) )
	{
		if(params[4] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve array from non-array ANY class"); }
		return -1;
	}
	register cell* arr = MF_GetAmxAddr(amx,params[2]);
	register size_t len = (static_cast<ucell>(params[3]) < tmp->size()) ? (params[3]) : (tmp->size());
	for(register size_t i = 0; i < len; i++)
	{
		arr[i] = (*tmp)[i];
	}

	return len;
}

// deque_peek_front_string(Deque:me,arr[],len,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	deque_peek_front_string(AMX *amx,cell *params)
{
	any_deque* tmp_deque = reinterpret_cast<any_deque*>(params[1]);
	register String* tmp = tmp_deque->peek_front().getstring();

	if( (tmp == NULL) )
	{
		if(params[4] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve string from non-string ANY class"); }
		return -1;
	}

	return MF_SetAmxString(amx,params[2],tmp->c_str(),params[3]);
}

// deque_push_back(Deque:me,Any:add)
static cell AMX_NATIVE_CALL	deque_push_back(AMX *amx,cell *params)
{
	reinterpret_cast<any_deque*>(params[1])->
		push_back(*reinterpret_cast<Capsule*>(params[2]) );
	return 1;
}

// deque_push_back_none(Deque:me)
static cell AMX_NATIVE_CALL	deque_push_back_none(AMX *amx,cell *params)
{
	Capsule tmp; tmp.setnone();
	reinterpret_cast<any_deque*>(params[1])->push_back(tmp);
	return 1;
}

// deque_push_back_bool(Deque:me,bool:newval)
static cell AMX_NATIVE_CALL	deque_push_back_bool(AMX *amx,cell *params)
{
	Capsule tmp; tmp.setbool((params[2] == 1));
	reinterpret_cast<any_deque*>(params[1])->push_back(tmp);
	return 1;
}

// deque_push_back_int(Deque:me,cell:newval)
static cell AMX_NATIVE_CALL	deque_push_back_int(AMX *amx,cell *params)
{
	Capsule tmp; tmp.setint(params[2]);
	reinterpret_cast<any_deque*>(params[1])->push_back(tmp);
	return 1;
}

// deque_push_back_ptr(Deque:me,Ptr:newval)
static cell AMX_NATIVE_CALL	deque_push_back_ptr(AMX *amx,cell *params)
{
	Capsule tmp; tmp.setpointer(reinterpret_cast<void*>(params[2]));
	reinterpret_cast<any_deque*>(params[1])->push_back(tmp);
	return 1;
}

// deque_push_back_float(Deque:me,Float:newval)
static cell AMX_NATIVE_CALL	deque_push_back_float(AMX *amx,cell *params)
{
	Capsule tmp; tmp.setfloat(amx_ctof(params[2]));
	reinterpret_cast<any_deque*>(params[1])->push_back(tmp);
	return 1;
}

// deque_push_back_deque(Deque:me,Float:newval[3])
static cell AMX_NATIVE_CALL	deque_push_back_deque(AMX *amx,cell *params)
{
	cell* ptr = MF_GetAmxAddr(amx,params[2]);
	HLVector tty(amx_ctof(ptr[0]),amx_ctof(ptr[1]),amx_ctof(ptr[2]));

	Capsule tmp; tmp.setvector(tty);
	reinterpret_cast<any_deque*>(params[1])->push_back(tmp);
	return 1;
}

// deque_push_back_array(Deque:me,newval[],len)
static cell AMX_NATIVE_CALL	deque_push_back_array(AMX *amx,cell *params)
{
	cell* ptr = MF_GetAmxAddr(amx,params[2]);
	vector<cell> tty(ptr,params[3]);

	Capsule tmp; tmp.setarray(tty);
	reinterpret_cast<any_deque*>(params[1])->push_back(tmp);
	return 1;
}

// deque_push_back_string(Deque:me,newval[])
static cell AMX_NATIVE_CALL	deque_push_back_string(AMX *amx,cell *params)
{
	int iLen;
	char* ptr = MF_GetAmxString(amx,params[2],0,&iLen);
	String tty(ptr,iLen);

	Capsule tmp; tmp.setstring(tty);
	reinterpret_cast<any_deque*>(params[1])->push_back(tmp);
	return 1;
}

// Any:deque_peek_back(Deque:me)
static cell AMX_NATIVE_CALL	deque_peek_back(AMX *amx,cell *params)
{
	Capsule& tmp = reinterpret_cast<any_deque*>(params[1])->peek_back();
	return reinterpret_cast<cell>(&tmp);
}

// deque_peek_back_raw(Deque:me)
static cell AMX_NATIVE_CALL	deque_peek_back_raw(AMX *amx,cell *params)
{
	any_deque* tmp_deque = reinterpret_cast<any_deque*>(params[1]);
	
	return reinterpret_cast<cell>(tmp_deque->peek_back().getData() );
}

// bool:deque_peek_back_bool(Deque:me,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	deque_peek_back_bool(AMX *amx,cell *params)
{
	any_deque* tmp_deque = reinterpret_cast<any_deque*>(params[1]);
	bool* tmp = tmp_deque->peek_back().getbool();

	if( (tmp == NULL) )
	{
		if(params[2] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve boolean from non-boolean ANY class"); }
		return -1;
	}
	return static_cast<cell>(*tmp);
}

// cell:deque_peek_back_int(Deque:me,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	deque_peek_back_int(AMX *amx,cell *params)
{
	any_deque* tmp_deque = reinterpret_cast<any_deque*>(params[1]);
	cell* tmp = tmp_deque->peek_back().getint();

	if( (tmp == NULL) )
	{
		if(params[2] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve integer from non-integer ANY class"); }
		return -1;
	}
	return *tmp;
}

// Ptr:deque_peek_back_ptr(Deque:me,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	deque_peek_back_ptr(AMX *amx,cell *params)
{
	any_deque* tmp_deque = reinterpret_cast<any_deque*>(params[1]);
	void* tmp = tmp_deque->peek_back().getpointer();

	if( (tmp == NULL) )
	{
		if(params[2] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve pointer from non-pointer ANY class"); }
		return -1;
	}
	return reinterpret_cast<cell>(tmp);
}

// Float:deque_peek_back_float(Deque:me,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	deque_peek_back_float(AMX *amx,cell *params)
{
	any_deque* tmp_deque = reinterpret_cast<any_deque*>(params[1]);
	REAL* tmp = tmp_deque->peek_back().getfloat();

	if( (tmp == NULL) )
	{
		if(params[2] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve float from non-float ANY class"); }
		return -1;
	}
	return amx_ftoc(*tmp);
}

// deque_peek_back_deque(Deque:me,Float:vec[3],no_fatal_errors=0)
static cell AMX_NATIVE_CALL	deque_peek_back_deque(AMX *amx,cell *params)
{
	any_deque* tmp_deque = reinterpret_cast<any_deque*>(params[1]);
	HLVector* tmp = tmp_deque->peek_back().getvector();

	if( (tmp == NULL) )
	{
		if(params[3] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve deque from non-deque ANY class"); }
		return -1;
	}
	cell* vec = MF_GetAmxAddr(amx,params[2]);

	vec[0] = amx_ftoc(tmp->x);
	vec[1] = amx_ftoc(tmp->y);
	vec[2] = amx_ftoc(tmp->z);

	return 1;
}

// deque_peek_back_array(Deque:me,arr[],len,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	deque_peek_back_array(AMX *amx,cell *params)
{
	any_deque* tmp_deque = reinterpret_cast<any_deque*>(params[1]);
	register vector<cell>* tmp = tmp_deque->peek_back().getarray();

	if( (tmp == NULL) )
	{
		if(params[4] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve array from non-array ANY class"); }
		return -1;
	}
	register cell* arr = MF_GetAmxAddr(amx,params[2]);
	register size_t len = (static_cast<ucell>(params[3]) < tmp->size()) ? (params[3]) : (tmp->size());
	for(register size_t i = 0; i < len; i++)
	{
		arr[i] = (*tmp)[i];
	}

	return len;
}

// deque_peek_back_string(Deque:me,arr[],len,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	deque_peek_back_string(AMX *amx,cell *params)
{
	any_deque* tmp_deque = reinterpret_cast<any_deque*>(params[1]);
	register String* tmp = tmp_deque->peek_back().getstring();

	if( (tmp == NULL) )
	{
		if(params[4] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve string from non-string ANY class"); }
		return -1;
	}

	return MF_SetAmxString(amx,params[2],tmp->c_str(),params[3]);
}

AMX_NATIVE_INFO deque_Natives[] =
{
	{"deque_create",		deque_create},
	{"deque_destroy",		deque_destroy},

	{"deque_clear",		deque_clear},
	{"deque_copy",		deque_copy},

	{"deque_comp",		deque_comp},
	{"deque_lex",		deque_lex},

	{"deque_end",		deque_end},
	{"deque_begin",		deque_begin},
	{"deque_at",		deque_at},

	{"deque_rend",		deque_rend},
	{"deque_rbegin",	deque_rbegin},
	{"deque_rat",		deque_rat},

	{"deque_empty",		deque_empty},
	{"deque_size",			deque_size},
	{"deque_memory",		deque_memory},

	{"deque_pop_back",		deque_pop_back},
	{"deque_pop_front",		deque_pop_front},

	{"deque_get",			deque_get},
	{"deque_get_raw",		deque_get_raw},
	{"deque_get_bool",		deque_get_bool},
	{"deque_get_int",		deque_get_int},
	{"deque_get_float",		deque_get_float},
	{"deque_get_ptr",		deque_get_ptr},
	{"deque_get_deque",		deque_get_deque},
	{"deque_get_array",		deque_get_array},
	{"deque_get_string",	deque_get_string},

	{"deque_set",				deque_set},
	{"deque_set_none",			deque_set_none},
	{"deque_set_bool",			deque_set_bool},
	{"deque_set_int",			deque_set_int},
	{"deque_set_float",			deque_set_float},
	{"deque_set_ptr",			deque_set_ptr},
	{"deque_set_deque",			deque_set_deque},
	{"deque_set_array",			deque_set_array},
	{"deque_set_string",		deque_set_string},

	{"deque_peek_front",			deque_peek_front},
	{"deque_peek_front_raw",		deque_peek_front_raw},
	{"deque_peek_front_bool",		deque_peek_front_bool},
	{"deque_peek_front_int",		deque_peek_front_int},
	{"deque_peek_front_float",		deque_peek_front_float},
	{"deque_peek_front_ptr",		deque_peek_front_ptr},
	{"deque_peek_front_deque",		deque_peek_front_deque},
	{"deque_peek_front_array",		deque_peek_front_array},
	{"deque_peek_front_string",		deque_peek_front_string},

	{"deque_push_front",			deque_push_front},
	{"deque_push_front_none",		deque_push_front_none},
	{"deque_push_front_bool",		deque_push_front_bool},
	{"deque_push_front_int",		deque_push_front_int},
	{"deque_push_front_float",		deque_push_front_float},
	{"deque_push_front_ptr",		deque_push_front_ptr},
	{"deque_push_front_deque",		deque_push_front_deque},
	{"deque_push_front_array",		deque_push_front_array},
	{"deque_push_front_string",		deque_push_front_string},

	{"deque_peek_back",			deque_peek_back},
	{"deque_peek_back_raw",		deque_peek_back_raw},
	{"deque_peek_back_bool",	deque_peek_back_bool},
	{"deque_peek_back_int",		deque_peek_back_int},
	{"deque_peek_back_float",	deque_peek_back_float},
	{"deque_peek_back_ptr",		deque_peek_back_ptr},
	{"deque_peek_back_deque",	deque_peek_back_deque},
	{"deque_peek_back_array",	deque_peek_back_array},
	{"deque_peek_back_string",	deque_peek_back_string},

	{"deque_push_back",			deque_push_back},
	{"deque_push_back_none",	deque_push_back_none},
	{"deque_push_back_bool",	deque_push_back_bool},
	{"deque_push_back_int",		deque_push_back_int},
	{"deque_push_back_float",	deque_push_back_float},
	{"deque_push_back_ptr",		deque_push_back_ptr},
	{"deque_push_back_deque",	deque_push_back_deque},
	{"deque_push_back_array",	deque_push_back_array},
	{"deque_push_back_string",	deque_push_back_string},

	{"deque_front",				deque_front},
	{"deque_front_raw",			deque_front_raw},
	{"deque_front_bool",		deque_front_bool},
	{"deque_front_int",			deque_front_int},
	{"deque_front_float",		deque_front_float},
	{"deque_front_ptr",			deque_front_ptr},
	{"deque_front_deque",		deque_front_deque},
	{"deque_front_array",		deque_front_array},
	{"deque_front_string",		deque_front_string},

	{"deque_back",				deque_back},
	{"deque_back_raw",			deque_back_raw},
	{"deque_back_bool",			deque_back_bool},
	{"deque_back_int",			deque_back_int},
	{"deque_back_float",		deque_back_float},
	{"deque_back_ptr",			deque_back_ptr},
	{"deque_back_deque",		deque_back_deque},
	{"deque_back_array",		deque_back_array},
	{"deque_back_string",		deque_back_string},

	{ NULL,				NULL}
};