#ifndef __FUNC___
#define __FUNC___

// Rukia: This document is in no way ehaustive; I don't have the energy to recode all of the STL functors.
//	What I did code was a few macros, and let them epand all the commonly used ones for me.
//	The format is conceptually the same as SGI, though its not the same code. 
//	This is because I basically memorized most of SGI's crazy synta.

//	Done:
//	All basic math
//	All logical math
//	All comparisons

// Unary functor; takes one arguement. Very few of these.
template <typename A, typename R>
struct unary_functor
{
	typedef A only_arg_t;
	typedef R result_t;
};

// Rukia: The most commonly used functors, the binary functors.
//	Takes two arguements, does something, returns a third.
template <typename A1, typename A2, typename R>
struct binary_functor
{
	typedef A1 first_arg_t;
	typedef A2 last_arg_t;
	typedef R result_t;
};

// Rukia: Math functor; does a math operation.
template <typename T>
struct math_functor: public binary_functor <T, T, T>
{
	typedef T args_t;
};

// Rukia: Epands into a full blown (T)functor(T T) math functortion.
#define MATH_FUNCTOR(name,op) \
template <typename T> \
struct name : public math_functor <T> \
{ T operator() (const T& one, const T& two) const { return (one) op (two); } }

// Rukia: Comparison functor; does a comparison operation.
template <typename T>
struct comp_functor: public binary_functor<T, T, bool>
{
	typedef T args_t;
};

// Rukia: Epands into a full blown (bool)functor(T T) functor object.
#define COMP_FUNCTOR(name,op) \
template <typename T> \
struct name : public comp_functor <T> \
{ bool operator() (const T& one, const T& two) const { return (one) op (two); } }

// Rukia: Math functors
template <typename T>
struct negate : public unary_functor <T, T> 
	{ T operator() (const T& one) const 
		{ return -one; } };

MATH_FUNCTOR(plus,+);
MATH_FUNCTOR(minus,-);
MATH_FUNCTOR(multiplies,*);
MATH_FUNCTOR(divides,/);
MATH_FUNCTOR(modulus,%);

// Rukia: Logical comparisons
template <typename T>
struct logical_not : public unary_functor <T, bool> 
	{ bool operator() (const T& one) const 
		{ return !one; } };

COMP_FUNCTOR(logical_or,||);
COMP_FUNCTOR(logical_xor,^);
COMP_FUNCTOR(logical_and,&&);

// Rukia: Identity comparisons
COMP_FUNCTOR(equal_to,==);
COMP_FUNCTOR(not_equal_to,!=);

// Rukia: Leicon comparisons
COMP_FUNCTOR(less,<);
COMP_FUNCTOR(less_equal,<=);
COMP_FUNCTOR(greater,>);
COMP_FUNCTOR(greater_equal,>=);

// Rukia: ToDo: Binders and the rest. I just don't need em right now.

#endif 
