
#include "pawn_iterator.h"

// iterator_copy(Iterator:me,Iterator:cpy)
static cell AMX_NATIVE_CALL	iterator_copy(AMX *amx,cell *params)
{
	any_iterator* tmp = reinterpret_cast<any_iterator*>(params[1]);
	any_iterator* tmp2 = reinterpret_cast<any_iterator*>(params[2]);
	(*tmp) = (*tmp2);
	return reinterpret_cast<cell>(tmp);
}

// iterator_comp(Iterator:me,Iterator:cpy)
static cell AMX_NATIVE_CALL	iterator_comp(AMX *amx,cell *params)
{
	any_iterator* tmp = reinterpret_cast<any_iterator*>(params[1]);
	any_iterator* tmp2 = reinterpret_cast<any_iterator*>(params[2]);
	return (*tmp) == (*tmp2);
}

// iterator_lex(Iterator:me,Iterator:cpy)
static cell AMX_NATIVE_CALL	iterator_lex(AMX *amx,cell *params)
{
	any_iterator* tmp = reinterpret_cast<any_iterator*>(params[1]);
	any_iterator* tmp2 = reinterpret_cast<any_iterator*>(params[2]);
	return (*tmp) < (*tmp2);
}

// iterator_destroy(Iterator:me)
static cell AMX_NATIVE_CALL	iterator_destroy(AMX *amx,cell *params)
{
	any_iterator* tmp = reinterpret_cast<any_iterator*>(params[1]);
	delete tmp;
	return 1;
}

// iterator_add(Iterator:me,amount = 1)
static cell AMX_NATIVE_CALL	iterator_add(AMX *amx,cell *params)
{
	any_iterator* tmp = reinterpret_cast<any_iterator*>(params[1]);
	(*tmp) += params[2];
	return reinterpret_cast<cell>(tmp);
}

// iterator_sub(Iterator:me,amount = 1)
static cell AMX_NATIVE_CALL	iterator_sub(AMX *amx,cell *params)
{
	any_iterator* tmp = reinterpret_cast<any_iterator*>(params[1]);
	(*tmp) -= params[2];
	return reinterpret_cast<cell>(tmp);
}

// Rukia: This makes me nervous...it doesn't follow the same rules as other Any: tags.
//	This is literally a reference to an already allocated, and non-destroyable, Capsule.
// Any:iterator_get(Iterator:me)
static cell AMX_NATIVE_CALL	iterator_get(AMX *amx,cell *params)
{
	any_iterator* tmp = reinterpret_cast<any_iterator*>(params[1]);
	Capsule& tty = *(*tmp);

	return reinterpret_cast<cell>( &tty );
}

// iterator_set(Iterator:me,Any:newval)
static cell AMX_NATIVE_CALL	iterator_set(AMX *amx,cell *params)
{
	any_iterator* tmp = reinterpret_cast<any_iterator*>(params[1]);
	Capsule* tty = reinterpret_cast<Capsule*>(params[2]);

	*(*tmp) = (*tty);
	return 1;
}

// iterator_set_none(Iterator:me)
static cell AMX_NATIVE_CALL	iterator_set_none(AMX *amx,cell *params)
{
	Capsule tmp; tmp.setnone();
	*(*reinterpret_cast<any_iterator*>(params[1])) = tmp;
	return 1;
}

// iterator_set_bool(Iterator:me,bool:newval)
static cell AMX_NATIVE_CALL	iterator_set_bool(AMX *amx,cell *params)
{
	Capsule tmp; tmp.setbool((params[2] == 1));
	*(*reinterpret_cast<any_iterator*>(params[1])) = tmp;
	return 1;
}

// iterator_set_int(Iterator:me,cell:newval)
static cell AMX_NATIVE_CALL	iterator_set_int(AMX *amx,cell *params)
{
	Capsule tmp; tmp.setint(params[2]);
	*(*reinterpret_cast<any_iterator*>(params[1])) = tmp;
	return 1;
}

// iterator_set_ptr(Iterator:me,Ptr:newval)
static cell AMX_NATIVE_CALL	iterator_set_ptr(AMX *amx,cell *params)
{
	Capsule tmp; tmp.setpointer(reinterpret_cast<void*>(params[2]));
	*(*reinterpret_cast<any_iterator*>(params[1])) = tmp;
	return 1;
}

// iterator_set_float(Iterator:me,Float:newval)
static cell AMX_NATIVE_CALL	iterator_set_float(AMX *amx,cell *params)
{
	Capsule tmp; tmp.setfloat(amx_ctof(params[2]));
	*(*reinterpret_cast<any_iterator*>(params[1])) = tmp;
	return 1;
}

// iterator_set_vector(Iterator:me,Float:newval[3])
static cell AMX_NATIVE_CALL	iterator_set_vector(AMX *amx,cell *params)
{
	cell* ptr = MF_GetAmxAddr(amx,params[2]);
	HLVector tty(amx_ctof(ptr[0]),amx_ctof(ptr[1]),amx_ctof(ptr[2]));

	Capsule tmp; tmp.setvector(tty);
	*(*reinterpret_cast<any_iterator*>(params[1])) = tmp;
	return 1;
}

// iterator_set_array(Iterator:me,newval[],len)
static cell AMX_NATIVE_CALL	iterator_set_array(AMX *amx,cell *params)
{
	cell* ptr = MF_GetAmxAddr(amx,params[2]);
	vector<cell> tty(ptr,params[3]);

	Capsule tmp; tmp.setarray(tty);
	*(*reinterpret_cast<any_iterator*>(params[1])) = tmp;
	return 1;
}

// iterator_set_string(Iterator:me,newval[])
static cell AMX_NATIVE_CALL	iterator_set_string(AMX *amx,cell *params)
{
	int iLen;
	char* ptr = MF_GetAmxString(amx,params[2],0,&iLen);
	String tty(ptr,iLen);

	Capsule tmp; tmp.setstring(tty);
	*(*reinterpret_cast<any_iterator*>(params[1])) = tmp;
	return 1;
}

// iterator_get_raw(Iterator:me)
static cell AMX_NATIVE_CALL	iterator_get_raw(AMX *amx,cell *params)
{
	any_iterator* tmp_iterator = reinterpret_cast<any_iterator*>(params[1]);
	
	return reinterpret_cast<cell>( (*(*tmp_iterator)).getData() );
}

// bool:iterator_get_bool(Iterator:me,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	iterator_get_bool(AMX *amx,cell *params)
{
	any_iterator* tmp_iterator = reinterpret_cast<any_iterator*>(params[1]);
	bool* tmp = (*(*tmp_iterator)).getbool();

	if( (tmp == NULL) )
	{
		if(params[2] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve boolean from non-boolean ANY class"); }
		return -1;
	}
	return static_cast<cell>(*tmp);
}

// cell:iterator_get_int(Iterator:me,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	iterator_get_int(AMX *amx,cell *params)
{
	any_iterator* tmp_iterator = reinterpret_cast<any_iterator*>(params[1]);
	cell* tmp = (*(*tmp_iterator)).getint();

	if( (tmp == NULL) )
	{
		if(params[2] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve integer from non-integer ANY class"); }
		return -1;
	}
	return *tmp;
}

// Ptr:iterator_get_ptr(Iterator:me,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	iterator_get_ptr(AMX *amx,cell *params)
{
	any_iterator* tmp_iterator = reinterpret_cast<any_iterator*>(params[1]);
	void* tmp = (*(*tmp_iterator)).getpointer();

	if( (tmp == NULL) )
	{
		if(params[2] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve pointer from non-pointer ANY class"); }
		return -1;
	}
	return reinterpret_cast<cell>(tmp);
}

// Float:iterator_get_float(Iterator:me,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	iterator_get_float(AMX *amx,cell *params)
{
	any_iterator* tmp_iterator = reinterpret_cast<any_iterator*>(params[1]);
	REAL* tmp = (*(*tmp_iterator)).getfloat();

	if( (tmp == NULL) )
	{
		if(params[2] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve float from non-float ANY class"); }
		return -1;
	}
	return amx_ftoc(*tmp);
}

// iterator_get_vector(Iterator:me,Float:vec[3],no_fatal_errors=0)
static cell AMX_NATIVE_CALL	iterator_get_vector(AMX *amx,cell *params)
{
	any_iterator* tmp_iterator = reinterpret_cast<any_iterator*>(params[1]);
	HLVector* tmp = (*(*tmp_iterator)).getvector();

	if( (tmp == NULL) )
	{
		if(params[3] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve vector from non-vector ANY class"); }
		return -1;
	}
	cell* vec = MF_GetAmxAddr(amx,params[2]);

	vec[0] = amx_ftoc(tmp->x);
	vec[1] = amx_ftoc(tmp->y);
	vec[2] = amx_ftoc(tmp->z);

	return 1;
}

// iterator_get_array(Iterator:me,arr[],len,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	iterator_get_array(AMX *amx,cell *params)
{
	any_iterator* tmp_iterator = reinterpret_cast<any_iterator*>(params[1]);
	register vector<cell>* tmp = (*(*tmp_iterator)).getarray();

	if( (tmp == NULL) )
	{
		if(params[4] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve array from non-array ANY class"); }
		return -1;
	}
	register cell* arr = MF_GetAmxAddr(amx,params[2]);
	register size_t len = (static_cast<ucell>(params[3]) < tmp->size()) ? (params[3]) : (tmp->size());
	for(register size_t i = 0; i < len; i++)
	{
		arr[i] = (*tmp)[i];
	}

	return len;
}

// iterator_get_string(Iterator:me,arr[],len,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	iterator_get_string(AMX *amx,cell *params)
{
	any_iterator* tmp_iterator = reinterpret_cast<any_iterator*>(params[1]);
	register String* tmp = (*(*tmp_iterator)).getstring();

	if( (tmp == NULL) )
	{
		if(params[4] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve string from non-string ANY class"); }
		return -1;
	}

	return MF_SetAmxString(amx,params[2],tmp->c_str(),params[3]);
}

// Any:iterator_get_key(Iterator:me)
static cell AMX_NATIVE_CALL	iterator_get_key(AMX *amx,cell *params)
{
	any_iterator* tmp = reinterpret_cast<any_iterator*>(params[1]);
	Capsule& tty = (*tmp).iterAt();

	return reinterpret_cast<cell>( &tty );
}

// iterator_get_key_raw(Iterator:me)
static cell AMX_NATIVE_CALL	iterator_get_key_raw(AMX *amx,cell *params)
{
	any_iterator* tmp_iterator = reinterpret_cast<any_iterator*>(params[1]);
	
	return reinterpret_cast<cell>( (*tmp_iterator).iterAt().getData() );
}

// bool:iterator_get_key_bool(Iterator:me,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	iterator_get_key_bool(AMX *amx,cell *params)
{
	any_iterator* tmp_iterator = reinterpret_cast<any_iterator*>(params[1]);
	bool* tmp = (*tmp_iterator).iterAt().getbool();

	if( (tmp == NULL) )
	{
		if(params[2] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve boolean from non-boolean ANY class"); }
		return -1;
	}
	return static_cast<cell>(*tmp);
}

// cell:iterator_get_key_int(Iterator:me,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	iterator_get_key_int(AMX *amx,cell *params)
{
	any_iterator* tmp_iterator = reinterpret_cast<any_iterator*>(params[1]);
	cell* tmp = (*tmp_iterator).iterAt().getint();

	if( (tmp == NULL) )
	{
		if(params[2] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve integer from non-integer ANY class"); }
		return -1;
	}
	return *tmp;
}

// Ptr:iterator_get_key_ptr(Iterator:me,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	iterator_get_key_ptr(AMX *amx,cell *params)
{
	any_iterator* tmp_iterator = reinterpret_cast<any_iterator*>(params[1]);
	void* tmp = (*tmp_iterator).iterAt().getpointer();

	if( (tmp == NULL) )
	{
		if(params[2] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve pointer from non-pointer ANY class"); }
		return -1;
	}
	return reinterpret_cast<cell>(tmp);
}

// Float:iterator_get_key_float(Iterator:me,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	iterator_get_key_float(AMX *amx,cell *params)
{
	any_iterator* tmp_iterator = reinterpret_cast<any_iterator*>(params[1]);
	REAL* tmp = (*tmp_iterator).iterAt().getfloat();

	if( (tmp == NULL) )
	{
		if(params[2] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve float from non-float ANY class"); }
		return -1;
	}
	return amx_ftoc(*tmp);
}

// iterator_get_key_vector(Iterator:me,Float:vec[3],no_fatal_errors=0)
static cell AMX_NATIVE_CALL	iterator_get_key_vector(AMX *amx,cell *params)
{
	any_iterator* tmp_iterator = reinterpret_cast<any_iterator*>(params[1]);
	HLVector* tmp = (*tmp_iterator).iterAt().getvector();

	if( (tmp == NULL) )
	{
		if(params[3] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve vector from non-vector ANY class"); }
		return -1;
	}
	cell* vec = MF_GetAmxAddr(amx,params[2]);

	vec[0] = amx_ftoc(tmp->x);
	vec[1] = amx_ftoc(tmp->y);
	vec[2] = amx_ftoc(tmp->z);

	return 1;
}

// iterator_get_key_array(Iterator:me,arr[],len,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	iterator_get_key_array(AMX *amx,cell *params)
{
	any_iterator* tmp_iterator = reinterpret_cast<any_iterator*>(params[1]);
	register vector<cell>* tmp = (*tmp_iterator).iterAt().getarray();

	if( (tmp == NULL) )
	{
		if(params[4] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve array from non-array ANY class"); }
		return -1;
	}
	register cell* arr = MF_GetAmxAddr(amx,params[2]);
	register size_t len = (static_cast<ucell>(params[3]) < tmp->size()) ? (params[3]) : (tmp->size());
	for(register size_t i = 0; i < len; i++)
	{
		arr[i] = (*tmp)[i];
	}

	return len;
}

// iterator_get_key_string(Iterator:me,arr[],len,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	iterator_get_key_string(AMX *amx,cell *params)
{
	any_iterator* tmp_iterator = reinterpret_cast<any_iterator*>(params[1]);
	register String* tmp = (*tmp_iterator).iterAt().getstring();

	if( (tmp == NULL) )
	{
		if(params[4] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve string from non-string ANY class"); }
		return -1;
	}

	return MF_SetAmxString(amx,params[2],tmp->c_str(),params[3]);
}

AMX_NATIVE_INFO iterator_Natives[] =
{
	{"iterator_destroy",		iterator_destroy},
	{"iterator_copy",		iterator_copy},

	{"iterator_comp",		iterator_comp},
	{"iterator_lex",		iterator_lex},

	{"iterator_add",		iterator_add},
	{"iterator_sub",		iterator_sub},

	{"iterator_set",		iterator_set},
	{"iterator_get_key",	iterator_get_key},
	{"iterator_get",		iterator_get},

	{"iterator_get_raw",		iterator_get_raw},
	{"iterator_set_none",		iterator_set_none},

	{"iterator_set_bool",		iterator_set_bool},
	{"iterator_get_bool",		iterator_get_bool},
	{"iterator_get_key_bool",	iterator_get_key_bool},

	{"iterator_set_int",		iterator_set_int},
	{"iterator_get_int",		iterator_get_int},
	{"iterator_get_key_int",		iterator_get_key_int},

	{"iterator_set_ptr",		iterator_set_ptr},
	{"iterator_get_ptr",		iterator_get_ptr},
	{"iterator_get_key_ptr",		iterator_get_key_ptr},

	{"iterator_set_float",		iterator_set_float},
	{"iterator_get_float",		iterator_get_float},
	{"iterator_get_key_float",		iterator_get_key_float},

	{"iterator_set_vector",		iterator_set_vector},
	{"iterator_get_vector",		iterator_get_vector},
	{"iterator_get_key_vector",		iterator_get_key_vector},

	{"iterator_set_array",		iterator_set_array},
	{"iterator_get_array",		iterator_get_array},
	{"iterator_get_key_array",		iterator_get_key_array},

	{"iterator_set_string",		iterator_set_string},
	{"iterator_get_string",		iterator_get_string},
	{"iterator_get_key_string",		iterator_get_key_string},

//	{"iterator_set_custom",		iterator_set_custom},
//	{"iterator_get_custom",		iterator_get_custom},
//	{"iterator_get_key_custom",		iterator_get_key_custom},
//	{"iterator_back_custom",		iterator_back_custom},

	{ NULL,				NULL}
};