#ifndef __PAIR___
#define __PAIR___

template <typename T1, typename T2>
class pair
{
public:
	T1 first;
	T2 second;
	
	pair() : first(T1()), second(T2()) 
	{ }

	pair(const T1& a, const T2& b) : first(a), second(b) 
	{ }

	pair(const pair<T1, T2>& p) : first(p.first), second(p.second) 
	{ }
};

template <typename T1, typename T2>
inline bool operator==(const pair<T1, T2>& x, const pair<T1, T2>& y)
	{ return x.first == y.first && x.second == y.second; }

template <typename T1, typename T2>
inline bool operator<(const pair<T1, T2>& x, const pair<T1, T2>& y)
	{ return (x.first < y.first) || (!(y.first < x.first) && (x.second < y.second) ); }

template <typename T1, typename T2>
inline bool operator!=(const pair<T1, T2>& x, const pair<T1, T2>& y) 
	{ return !(x == y); }

template <typename T1, typename T2>
inline bool operator>(const pair<T1, T2>& x, const pair<T1, T2>& y) 
	{ return y < x; }

template <typename T1, typename T2>
inline bool operator<=(const pair<T1, T2>& x, const pair<T1, T2>& y) 
	{ return !(y < x); }

template <typename T1, typename T2>
inline bool operator>=(const pair<T1, T2>& x, const pair<T1, T2>& y) 
	{ return !(x < y); }

template <typename T1, typename T2>
inline pair<T1, T2> makepair(const T1& x, const T2& y)
	{ return pair<T1, T2>(x, y); }

#endif
