#ifndef __STACK___
#define __STACK___
// Rukia: Thank god stacks and queues don't have iterators! Those things are driving me crazy!

#include "vector"

template <typename T, typename Sequence = vector<T> >
class stack
{
public: CONTAINER_TYPEDEF;
private: 
	Sequence internal_;
public:
	stack() : internal_()
	{ }
	stack(const stack& copy) : internal_(copy.internal_)
	{ }
	
	stack& operator=(const stack& copy)
		{ internal_ = copy.internal_; return *this; }

	bool operator==(const stack& other)
		{ return (internal_ == other.internal_); }

	bool operator<(const stack& other)
		{ return (internal_ < other.internal_); }

	void clear()
	{ internal_.clear(); }

	bool empty() const
		{ return internal_.empty(); }

	size_t size() const
		{ return internal_.size(); }

	reference top()
		{ return internal_.back(); }

	const_reference top() const
		{ return internal_.back(); }

	reference peek()
		{ return internal_.back(); }

	const_reference peek() const
		{ return internal_.back(); }

	void push(reference tmp)
		{ internal_.push_back(tmp); }

	void pop()
		{ internal_.pop_back(); }
};

// Rukia: Compare size first; if the sizes are not equal, they cannot be equal. This is a huge performance boost.
template <typename T, typename Sequence>
bool operator== (const stack<T,Sequence>& a, const stack<T,Sequence>& b)
{ 
	return ( (a.size() == b.size()) && (a == b) );
}

template <typename T, typename Sequence>
bool operator< (const stack<T,Sequence>& a, const stack<T,Sequence>& b)
{
	return ( (a < b) );
}

template < typename T, typename Alloc> inline bool operator != (const stack<T,Alloc>& a, const stack<T,Alloc>& b)
	{ return !(a == b); }

template < typename T, typename Alloc> inline bool operator > (const stack<T,Alloc>& a, const stack<T,Alloc>& b)
	{ return (b < a); }

template < typename T, typename Alloc> inline bool operator >= (const stack<T,Alloc>& a, const stack<T,Alloc>& b)
	{ return !(a < b); }

template < typename T, typename Alloc> inline bool operator <= (const stack<T,Alloc>& a, const stack<T,Alloc>& b)
	{ return !(b < a); }


#endif
