#include "amxxmodule.h"
#include "vector"
#include "capsule.h"
#include "pawn_iterator.h"

// Rukia: vectors last; iterators to deal with, complex interface.

typedef vector<Capsule> any_vector;

void* vector_iterator_func(PIterator* iter, size_t op, void* ptr)
{
	register any_vector::iterator* tmp = reinterpret_cast<any_vector::iterator*>(iter->iteratorptr);
	switch(op)
	{
		// (void) (NULL,NULL)
	case PIterator::ITERATOR_OP_CONSTRUCT: return reinterpret_cast<void*>(New<any_vector::iterator,Mallocator>() );
	// (NULL) (void*,NULL)
	case PIterator::ITERATOR_OP_COPY: 
		{
				register any_vector::iterator* tmp2 = (any_vector::iterator*)((PIterator*)ptr);
				*tmp = *tmp2;
				break;
		}
	//(void) (this,NULL)
	case PIterator::ITERATOR_OP_DECONSTRUCT: Delete<any_vector::iterator,Mallocator>((any_vector::iterator*)ptr,1); return NULL;

	// (void) (this,amount)
	case PIterator::ITERATOR_OP_PREFIX_ADD:
		{ *tmp += (size_t)ptr; break; }
	// (void) (this,amount)
	case PIterator::ITERATOR_OP_PREFIX_SUB:
		{ *tmp -= (size_t)ptr; break; }

	// (void*) (this,amount)
	//PIterator::ITERATOR_OP_POSTFIX_ADD:
	// (void*) (this,amount)
	//PIterator::ITERATOR_OP_POSTFIX_SUB:

	// (bool) (this,other)
	case PIterator::ITERATOR_OP_EQUALTO:
		{
				register any_vector::iterator* tmp2 = (any_vector::iterator*)((PIterator*)ptr);
				return (*tmp == *tmp2) ? (void*)1 : (void*)2;
		}
		
	// (bool) (this,other)
	case PIterator::ITERATOR_OP_LESSTHAN: 
		{
				register any_vector::iterator* tmp2 = (any_vector::iterator*)((PIterator*)ptr);
				return (*tmp < *tmp2) ? (void*)1 : (void*)2;
		}

	// (Capsule*) (this,NULL)
	case PIterator::ITERATOR_OP_DEREFERENCE:
		{
				static Capsule& tty = *(*tmp);
				return static_cast<void*>( &tty );
		}
	// (Capsule*) (this,NULL)
	case PIterator::ITERATOR_OP_KEY:
		{
			return (void*)NULL;
		}
	}
	return (void*)NULL;
}

// void Iterator:vector_begin(vector:designation,static = 0)
static cell AMX_NATIVE_CALL	vector_begin(AMX *amx,cell *params)
{
	any_iterator* tmp;
	if(params[2] == 1)
	{
		static any_iterator tty(vector_iterator_func);  
		tmp = &tty;
	}
	else tmp = New<any_iterator,Mallocator>(1,any_iterator(vector_iterator_func) );

	tmp->set(reinterpret_cast<any_vector*>(params[1])->begin());
	return reinterpret_cast<cell>(tmp);
}

// void Iterator:vector_end(vector:designation,static = 0)
static cell AMX_NATIVE_CALL	vector_end(AMX *amx,cell *params)
{
	any_iterator* tmp;
	if(params[2] == 1)
	{
		static any_iterator tty(vector_iterator_func);  
		tmp = &tty;
	}
	else tmp = New<any_iterator,Mallocator>(1,any_iterator(vector_iterator_func) );

	tmp->set(reinterpret_cast<any_vector*>(params[1])->end());
	return reinterpret_cast<cell>(tmp);
}

// void Iterator:vector_at(vector:designation,slot, static = 0)
static cell AMX_NATIVE_CALL	vector_at(AMX *amx,cell *params)
{
	any_iterator* tmp;
	if(params[3] == 1)
	{
		static any_iterator tty(vector_iterator_func);  
		tmp = &tty;
	}
	else tmp = New<any_iterator,Mallocator>(1,any_iterator(vector_iterator_func) );

	any_vector* tyt = reinterpret_cast<any_vector*>(params[1]);
	tmp->set(tyt->iterAt(params[2]));
	return reinterpret_cast<cell>(tmp);
}

void* vector_reverse_iterator_func(PIterator* iter, size_t op, void* ptr)
{
	register any_vector::reverse_iterator* tmp = reinterpret_cast<any_vector::reverse_iterator*>(iter->iteratorptr);
	switch(op)
	{
		// (void) (NULL,NULL)
	case PIterator::ITERATOR_OP_CONSTRUCT: return reinterpret_cast<void*>(New<any_vector::reverse_iterator,Mallocator>() );
	// (NULL) (void*,NULL)
	case PIterator::ITERATOR_OP_COPY: 
		{
				register any_vector::reverse_iterator* tmp2 = (any_vector::reverse_iterator*)((PIterator*)ptr);
				*tmp = *tmp2;
				break;
		}
	//(void) (this,NULL)
	case PIterator::ITERATOR_OP_DECONSTRUCT: Delete<any_vector::reverse_iterator,Mallocator>((any_vector::reverse_iterator*)ptr,1); return NULL;

	// (void) (this,amount)
	case PIterator::ITERATOR_OP_PREFIX_ADD:
		{ *tmp += (size_t)ptr; break; }
	// (void) (this,amount)
	case PIterator::ITERATOR_OP_PREFIX_SUB:
		{ *tmp -= (size_t)ptr; break; }

	// (void*) (this,amount)
	//PIterator::ITERATOR_OP_POSTFIX_ADD:
	// (void*) (this,amount)
	//PIterator::ITERATOR_OP_POSTFIX_SUB:

	// (bool) (this,other)
	case PIterator::ITERATOR_OP_EQUALTO:
		{
				register any_vector::reverse_iterator* tmp2 = (any_vector::reverse_iterator*)((PIterator*)ptr);
				return (*tmp == *tmp2) ? (void*)1 : (void*)2;
		}
		
	// (bool) (this,other)
	case PIterator::ITERATOR_OP_LESSTHAN: 
		{
				register any_vector::reverse_iterator* tmp2 = (any_vector::reverse_iterator*)((PIterator*)ptr);
				return (*tmp < *tmp2) ? (void*)1 : (void*)2;
		}

	// (Capsule*) (this,NULL)
	case PIterator::ITERATOR_OP_DEREFERENCE:
		{
				static Capsule& tty = *(*tmp);
				return static_cast<void*>( &tty );
		}
	// (Capsule*) (this,NULL)
	case PIterator::ITERATOR_OP_KEY:
		{
			return (void*)NULL;
		}
	}
	return (void*)NULL;
}


// void Iterator:vector_rbegin(vector:designation,static = 0)
static cell AMX_NATIVE_CALL	vector_rbegin(AMX *amx,cell *params)
{
	any_iterator* tmp;
	if(params[2] == 1)
	{
		static any_iterator tty(vector_reverse_iterator_func);  
		tmp = &tty;
	}
	else tmp = New<any_iterator,Mallocator>(1,any_iterator(vector_reverse_iterator_func) );

	tmp->set(reinterpret_cast<any_vector*>(params[1])->begin());
	return reinterpret_cast<cell>(tmp);
}

// void Iterator:vector_end(vector:designation,static = 0)
static cell AMX_NATIVE_CALL	vector_rend(AMX *amx,cell *params)
{
	any_iterator* tmp;
	if(params[2] == 1)
	{
		static any_iterator tty(vector_reverse_iterator_func);  
		tmp = &tty;
	}
	else tmp = New<any_iterator,Mallocator>(1,any_iterator(vector_reverse_iterator_func) );

	tmp->set(reinterpret_cast<any_vector*>(params[1])->end());
	return reinterpret_cast<cell>(tmp);
}

// void Iterator:vector_rat(vector:designation,slot, static = 0)
static cell AMX_NATIVE_CALL	vector_rat(AMX *amx,cell *params)
{
	any_iterator* tmp;
	if(params[3] == 1)
	{
		static any_iterator tty(vector_reverse_iterator_func);  
		tmp = &tty;
	}
	else tmp = New<any_iterator,Mallocator>(1,any_iterator(vector_reverse_iterator_func) );

	any_vector* tyt = reinterpret_cast<any_vector*>(params[1]);
	tmp->set(tyt->iterAt(tyt->size() - params[2]));
	return reinterpret_cast<cell>(tmp);
}

// vector:vector_create(vector:copy = NULL, static = 0)
static cell AMX_NATIVE_CALL	vector_create(AMX *amx,cell *params)
{
	any_vector* tmp;

	// Rukia: Copy another vector if necessary.
	if(params[2] == 1) { static any_vector tty; tmp = &tty; }
	else { tmp = New<any_vector, Mallocator >(); }

	if(params[1] != 0)
	{
		any_vector * tty = reinterpret_cast<any_vector * >(params[1]);
		*tmp = *tty;
	}

	return reinterpret_cast<cell>(tmp);
}

// void vector_copy(vector:designation,vector:source)
static cell AMX_NATIVE_CALL	vector_copy(AMX *amx,cell *params)
{
	any_vector* dsg = reinterpret_cast<any_vector*>(params[1]);
	any_vector* src = reinterpret_cast<any_vector*>(params[2]);

	*dsg = *src;
	return 1;
}

// void bool:vector_comp(vector:designation,vector:source)
static cell AMX_NATIVE_CALL	vector_comp(AMX *amx,cell *params)
{
	any_vector* dsg = reinterpret_cast<any_vector*>(params[1]);
	any_vector* src = reinterpret_cast<any_vector*>(params[2]);

	return (*dsg) == (*src);
}

// void bool:vector_lex(vector:designation,vector:source)
static cell AMX_NATIVE_CALL	vector_lex(AMX *amx,cell *params)
{
	any_vector* dsg = reinterpret_cast<any_vector*>(params[1]);
	any_vector* src = reinterpret_cast<any_vector*>(params[2]);

	return (*dsg) < (*src);
}

// Rukia: Not technically part of ANSI STL vectors; it matches our standard API though.
// void vector_clear(vector:me)
static cell AMX_NATIVE_CALL	vector_clear(AMX *amx,cell *params)
{
	reinterpret_cast<any_vector*>(params[1])->clear();

	return 1;
}

// vector:vector_destroy(vector:me)
static cell AMX_NATIVE_CALL	vector_destroy(AMX *amx,cell *params)
{
	Delete<any_vector, Mallocator >(reinterpret_cast<any_vector*>(params[1]),1);

	return 1;
}

// bool:vector_empty(vector:me)
static cell AMX_NATIVE_CALL	vector_empty(AMX *amx,cell *params)
{
	return static_cast<cell>(reinterpret_cast<any_vector*>(params[1])->empty() );
}

// Rukia: Unfortunately, to get this out, I have to give up finishing the allocator for a while.
//	Returns the amount of space wasted but not the exact total memory used.

// cell vector_memory(vector:me)
static cell AMX_NATIVE_CALL	vector_memory(AMX *amx,cell *params)
{
	return static_cast<cell>(reinterpret_cast<any_vector*>(params[1])->size() * sizeof(Capsule) );
}

// cell vector_size(vector:me)
static cell AMX_NATIVE_CALL	vector_size(AMX *amx,cell *params)
{
	return static_cast<cell>(reinterpret_cast<any_vector*>(params[1])->size() );
}

// vector_pop(vector:me)
static cell AMX_NATIVE_CALL	vector_pop(AMX *amx,cell *params)
{
	reinterpret_cast<any_vector*>(params[1])->pop_back();
	return 1;
}

// vector_push(vector:me,Any:add)
static cell AMX_NATIVE_CALL	vector_push(AMX *amx,cell *params)
{
	reinterpret_cast<any_vector*>(params[1])->
		push_back(*reinterpret_cast<Capsule*>(params[2]) );
	return 1;
}

// vector_push_none(vector:me)
static cell AMX_NATIVE_CALL	vector_push_none(AMX *amx,cell *params)
{
	Capsule tmp; tmp.setnone();
	reinterpret_cast<any_vector*>(params[1])->push_back(tmp);
	return 1;
}

// vector_push_bool(vector:me,bool:newval)
static cell AMX_NATIVE_CALL	vector_push_bool(AMX *amx,cell *params)
{
	Capsule tmp; tmp.setbool((params[2] == 1));
	reinterpret_cast<any_vector*>(params[1])->push_back(tmp);
	return 1;
}

// vector_push_int(vector:me,cell:newval)
static cell AMX_NATIVE_CALL	vector_push_int(AMX *amx,cell *params)
{
	Capsule tmp; tmp.setint(params[2]);
	reinterpret_cast<any_vector*>(params[1])->push_back(tmp);
	return 1;
}

// vector_push_ptr(vector:me,Ptr:newval)
static cell AMX_NATIVE_CALL	vector_push_ptr(AMX *amx,cell *params)
{
	Capsule tmp; tmp.setpointer(reinterpret_cast<void*>(params[2]));
	reinterpret_cast<any_vector*>(params[1])->push_back(tmp);
	return 1;
}

// vector_push_float(vector:me,Float:newval)
static cell AMX_NATIVE_CALL	vector_push_float(AMX *amx,cell *params)
{
	Capsule tmp; tmp.setfloat(amx_ctof(params[2]));
	reinterpret_cast<any_vector*>(params[1])->push_back(tmp);
	return 1;
}

// vector_push_vector(vector:me,Float:newval[3])
static cell AMX_NATIVE_CALL	vector_push_vector(AMX *amx,cell *params)
{
	cell* ptr = MF_GetAmxAddr(amx,params[2]);
	HLVector tty(amx_ctof(ptr[0]),amx_ctof(ptr[1]),amx_ctof(ptr[2]));

	Capsule tmp; tmp.setvector(tty);
	reinterpret_cast<any_vector*>(params[1])->push_back(tmp);
	return 1;
}

// vector_push_array(vector:me,newval[],len)
static cell AMX_NATIVE_CALL	vector_push_array(AMX *amx,cell *params)
{
	cell* ptr = MF_GetAmxAddr(amx,params[2]);
	vector<cell> tty(ptr,params[3]);

	Capsule tmp; tmp.setarray(tty);
	reinterpret_cast<any_vector*>(params[1])->push_back(tmp);
	return 1;
}

// vector_push_string(vector:me,newval[])
static cell AMX_NATIVE_CALL	vector_push_string(AMX *amx,cell *params)
{
	int iLen;
	char* ptr = MF_GetAmxString(amx,params[2],0,&iLen);
	String tty(ptr,iLen);

	Capsule tmp; tmp.setstring(tty);
	reinterpret_cast<any_vector*>(params[1])->push_back(tmp);
	return 1;
}

// Any:vector_peek(vector:me)
static cell AMX_NATIVE_CALL	vector_peek(AMX *amx,cell *params)
{
	Capsule& tmp = reinterpret_cast<any_vector*>(params[1])->peek_back();
	return reinterpret_cast<cell>(&tmp);
}

// vector_peek_raw(vector:me)
static cell AMX_NATIVE_CALL	vector_peek_raw(AMX *amx,cell *params)
{
	any_vector* tmp_vector = reinterpret_cast<any_vector*>(params[1]);
	
	return reinterpret_cast<cell>(tmp_vector->peek_back().getData() );
}

// bool:vector_peek_bool(vector:me,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	vector_peek_bool(AMX *amx,cell *params)
{
	any_vector* tmp_vector = reinterpret_cast<any_vector*>(params[1]);
	bool* tmp = tmp_vector->peek_back().getbool();

	if( (tmp == NULL) )
	{
		if(params[2] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve boolean from non-boolean ANY class"); }
		return -1;
	}
	return static_cast<cell>(*tmp);
}

// cell:vector_peek_int(vector:me,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	vector_peek_int(AMX *amx,cell *params)
{
	any_vector* tmp_vector = reinterpret_cast<any_vector*>(params[1]);
	cell* tmp = tmp_vector->peek_back().getint();

	if( (tmp == NULL) )
	{
		if(params[2] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve integer from non-integer ANY class"); }
		return -1;
	}
	return *tmp;
}

// Ptr:vector_peek_ptr(vector:me,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	vector_peek_ptr(AMX *amx,cell *params)
{
	any_vector* tmp_vector = reinterpret_cast<any_vector*>(params[1]);
	void* tmp = tmp_vector->peek_back().getpointer();

	if( (tmp == NULL) )
	{
		if(params[2] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve pointer from non-pointer ANY class"); }
		return -1;
	}
	return reinterpret_cast<cell>(tmp);
}

// Float:vector_peek_float(vector:me,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	vector_peek_float(AMX *amx,cell *params)
{
	any_vector* tmp_vector = reinterpret_cast<any_vector*>(params[1]);
	REAL* tmp = tmp_vector->peek_back().getfloat();

	if( (tmp == NULL) )
	{
		if(params[2] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve float from non-float ANY class"); }
		return -1;
	}
	return amx_ftoc(*tmp);
}

// vector_peek_vector(vector:me,Float:vec[3],no_fatal_errors=0)
static cell AMX_NATIVE_CALL	vector_peek_vector(AMX *amx,cell *params)
{
	any_vector* tmp_vector = reinterpret_cast<any_vector*>(params[1]);
	HLVector* tmp = tmp_vector->peek_back().getvector();

	if( (tmp == NULL) )
	{
		if(params[3] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve vector from non-vector ANY class"); }
		return -1;
	}
	cell* vec = MF_GetAmxAddr(amx,params[2]);

	vec[0] = amx_ftoc(tmp->x);
	vec[1] = amx_ftoc(tmp->y);
	vec[2] = amx_ftoc(tmp->z);

	return 1;
}

// vector_peek_array(vector:me,arr[],len,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	vector_peek_array(AMX *amx,cell *params)
{
	any_vector* tmp_vector = reinterpret_cast<any_vector*>(params[1]);
	register vector<cell>* tmp = tmp_vector->peek_back().getarray();

	if( (tmp == NULL) )
	{
		if(params[4] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve array from non-array ANY class"); }
		return -1;
	}
	register cell* arr = MF_GetAmxAddr(amx,params[2]);
	register size_t len = (static_cast<ucell>(params[3]) < tmp->size()) ? (params[3]) : (tmp->size());
	for(register size_t i = 0; i < len; i++)
	{
		arr[i] = (*tmp)[i];
	}

	return len;
}

// vector_peek_string(vector:me,arr[],len,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	vector_peek_string(AMX *amx,cell *params)
{
	any_vector* tmp_vector = reinterpret_cast<any_vector*>(params[1]);
	register String* tmp = tmp_vector->peek_back().getstring();

	if( (tmp == NULL) )
	{
		if(params[4] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve string from non-string ANY class"); }
		return -1;
	}

	return MF_SetAmxString(amx,params[2],tmp->c_str(),params[3]);
}

// Any:vector_front(vector:me)
static cell AMX_NATIVE_CALL	vector_front(AMX *amx,cell *params)
{
	return reinterpret_cast<cell>(&reinterpret_cast<any_vector*>(params[1])->front() );
}

// vector_front_raw(vector:me)
static cell AMX_NATIVE_CALL	vector_front_raw(AMX *amx,cell *params)
{
	any_vector* tmp_vector = reinterpret_cast<any_vector*>(params[1]);
	
	return reinterpret_cast<cell>(tmp_vector->front().getData() );
}

// bool:vector_front_bool(vector:me,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	vector_front_bool(AMX *amx,cell *params)
{
	any_vector* tmp_vector = reinterpret_cast<any_vector*>(params[1]);
	bool* tmp = tmp_vector->front().getbool();

	if( (tmp == NULL) )
	{
		if(params[2] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve boolean from non-boolean ANY class"); }
		return -1;
	}
	return static_cast<cell>(*tmp);
}

// cell:vector_front_int(vector:me,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	vector_front_int(AMX *amx,cell *params)
{
	any_vector* tmp_vector = reinterpret_cast<any_vector*>(params[1]);
	cell* tmp = tmp_vector->front().getint();

	if( (tmp == NULL) )
	{
		if(params[2] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve integer from non-integer ANY class"); }
		return -1;
	}
	return *tmp;
}

// Ptr:vector_front_ptr(vector:me,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	vector_front_ptr(AMX *amx,cell *params)
{
	any_vector* tmp_vector = reinterpret_cast<any_vector*>(params[1]);
	void* tmp = tmp_vector->front().getpointer();

	if( (tmp == NULL) )
	{
		if(params[2] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve pointer from non-pointer ANY class"); }
		return -1;
	}
	return reinterpret_cast<cell>(tmp);
}

// Float:vector_front_float(vector:me,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	vector_front_float(AMX *amx,cell *params)
{
	any_vector* tmp_vector = reinterpret_cast<any_vector*>(params[1]);
	REAL* tmp = tmp_vector->front().getfloat();

	if( (tmp == NULL) )
	{
		if(params[2] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve float from non-float ANY class"); }
		return -1;
	}
	return amx_ftoc(*tmp);
}

// vector_front_vector(vector:me,Float:vec[3],no_fatal_errors=0)
static cell AMX_NATIVE_CALL	vector_front_vector(AMX *amx,cell *params)
{
	any_vector* tmp_vector = reinterpret_cast<any_vector*>(params[1]);
	HLVector* tmp = tmp_vector->front().getvector();

	if( (tmp == NULL) )
	{
		if(params[3] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve vector from non-vector ANY class"); }
		return -1;
	}
	cell* vec = MF_GetAmxAddr(amx,params[2]);

	vec[0] = amx_ftoc(tmp->x);
	vec[1] = amx_ftoc(tmp->y);
	vec[2] = amx_ftoc(tmp->z);

	return 1;
}

// vector_front_array(vector:me,arr[],len,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	vector_front_array(AMX *amx,cell *params)
{
	any_vector* tmp_vector = reinterpret_cast<any_vector*>(params[1]);
	register vector<cell>* tmp = tmp_vector->front().getarray();

	if( (tmp == NULL) )
	{
		if(params[4] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve array from non-array ANY class"); }
		return -1;
	}
	register cell* arr = MF_GetAmxAddr(amx,params[2]);
	register size_t len = (static_cast<ucell>(params[3]) < tmp->size()) ? (params[3]) : (tmp->size());
	for(register size_t i = 0; i < len; i++)
	{
		arr[i] = (*tmp)[i];
	}

	return len;
}

// vector_front_string(vector:me,arr[],len,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	vector_front_string(AMX *amx,cell *params)
{
	any_vector* tmp_vector = reinterpret_cast<any_vector*>(params[1]);
	register String* tmp = tmp_vector->front().getstring();

	if( (tmp == NULL) )
	{
		if(params[4] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve string from non-string ANY class"); }
		return -1;
	}

	return MF_SetAmxString(amx,params[2],tmp->c_str(),params[3]);
}

// Any:vector_back(vector:me)
static cell AMX_NATIVE_CALL	vector_back(AMX *amx,cell *params)
{
	return reinterpret_cast<cell>(&reinterpret_cast<any_vector*>(params[1])->back() );
}

// vector_back_raw(vector:me)
static cell AMX_NATIVE_CALL	vector_back_raw(AMX *amx,cell *params)
{
	any_vector* tmp_vector = reinterpret_cast<any_vector*>(params[1]);
	
	return reinterpret_cast<cell>(tmp_vector->back().getData() );
}

// bool:vector_back_bool(vector:me,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	vector_back_bool(AMX *amx,cell *params)
{
	any_vector* tmp_vector = reinterpret_cast<any_vector*>(params[1]);
	bool* tmp = tmp_vector->back().getbool();

	if( (tmp == NULL) )
	{
		if(params[2] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve boolean from non-boolean ANY class"); }
		return -1;
	}
	return static_cast<cell>(*tmp);
}

// cell:vector_back_int(vector:me,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	vector_back_int(AMX *amx,cell *params)
{
	any_vector* tmp_vector = reinterpret_cast<any_vector*>(params[1]);
	cell* tmp = tmp_vector->back().getint();

	if( (tmp == NULL) )
	{
		if(params[2] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve integer from non-integer ANY class"); }
		return -1;
	}
	return *tmp;
}

// Ptr:vector_back_ptr(vector:me,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	vector_back_ptr(AMX *amx,cell *params)
{
	any_vector* tmp_vector = reinterpret_cast<any_vector*>(params[1]);
	void* tmp = tmp_vector->back().getpointer();

	if( (tmp == NULL) )
	{
		if(params[2] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve pointer from non-pointer ANY class"); }
		return -1;
	}
	return reinterpret_cast<cell>(tmp);
}

// Float:vector_back_float(vector:me,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	vector_back_float(AMX *amx,cell *params)
{
	any_vector* tmp_vector = reinterpret_cast<any_vector*>(params[1]);
	REAL* tmp = tmp_vector->back().getfloat();

	if( (tmp == NULL) )
	{
		if(params[2] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve float from non-float ANY class"); }
		return -1;
	}
	return amx_ftoc(*tmp);
}

// vector_back_vector(vector:me,Float:vec[3],no_fatal_errors=0)
static cell AMX_NATIVE_CALL	vector_back_vector(AMX *amx,cell *params)
{
	any_vector* tmp_vector = reinterpret_cast<any_vector*>(params[1]);
	HLVector* tmp = tmp_vector->back().getvector();

	if( (tmp == NULL) )
	{
		if(params[3] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve vector from non-vector ANY class"); }
		return -1;
	}
	cell* vec = MF_GetAmxAddr(amx,params[2]);

	vec[0] = amx_ftoc(tmp->x);
	vec[1] = amx_ftoc(tmp->y);
	vec[2] = amx_ftoc(tmp->z);

	return 1;
}

// vector_back_array(vector:me,arr[],len,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	vector_back_array(AMX *amx,cell *params)
{
	any_vector* tmp_vector = reinterpret_cast<any_vector*>(params[1]);
	register vector<cell>* tmp = tmp_vector->back().getarray();

	if( (tmp == NULL) )
	{
		if(params[4] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve array from non-array ANY class"); }
		return -1;
	}
	register cell* arr = MF_GetAmxAddr(amx,params[2]);
	register size_t len = (static_cast<ucell>(params[3]) < tmp->size()) ? (params[3]) : (tmp->size());
	for(register size_t i = 0; i < len; i++)
	{
		arr[i] = (*tmp)[i];
	}

	return len;
}

// vector_back_string(vector:me,arr[],len,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	vector_back_string(AMX *amx,cell *params)
{
	any_vector* tmp_vector = reinterpret_cast<any_vector*>(params[1]);
	register String* tmp = tmp_vector->back().getstring();

	if( (tmp == NULL) )
	{
		if(params[4] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve string from non-string ANY class"); }
		return -1;
	}

	return MF_SetAmxString(amx,params[2],tmp->c_str(),params[3]);
}



// Any:vector_get(vector:me,slot)
static cell AMX_NATIVE_CALL	vector_get(AMX *amx,cell *params)
{
	any_vector* tmp_vector = reinterpret_cast<any_vector*>(params[1]);
	
	return reinterpret_cast<cell>( &((*tmp_vector)[params[2]]) );
}

// vector_get_raw(vector:me,slot)
static cell AMX_NATIVE_CALL	vector_get_raw(AMX *amx,cell *params)
{
	any_vector* tmp_vector = reinterpret_cast<any_vector*>(params[1]);
	
	return reinterpret_cast<cell>((*tmp_vector)[params[2]].getData() );
}

// bool:vector_get_bool(vector:me,slot,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	vector_get_bool(AMX *amx,cell *params)
{
	any_vector* tmp_vector = reinterpret_cast<any_vector*>(params[1]);
	bool* tmp = (*tmp_vector)[params[2]].getbool();

	if( (tmp == NULL) )
	{
		if(params[3] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve boolean from non-boolean ANY class"); }
		return -1;
	}
	return static_cast<cell>(*tmp);
}

// cell:vector_get_int(vector:me,slot,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	vector_get_int(AMX *amx,cell *params)
{
	any_vector* tmp_vector = reinterpret_cast<any_vector*>(params[1]);
	cell* tmp = (*tmp_vector)[params[2]].getint();

	if( (tmp == NULL) )
	{
		if(params[3] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve integer from non-integer ANY class"); }
		return -1;
	}
	return *tmp;
}

// Ptr:vector_get_ptr(vector:me,slot,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	vector_get_ptr(AMX *amx,cell *params)
{
	any_vector* tmp_vector = reinterpret_cast<any_vector*>(params[1]);
	void* tmp = (*tmp_vector)[params[2]].getpointer();

	if( (tmp == NULL) )
	{
		if(params[3] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve pointer from non-pointer ANY class"); }
		return -1;
	}
	return reinterpret_cast<cell>(tmp);
}

// Float:vector_get_float(vector:me,slot,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	vector_get_float(AMX *amx,cell *params)
{
	any_vector* tmp_vector = reinterpret_cast<any_vector*>(params[1]);
	REAL* tmp = (*tmp_vector)[params[2]].getfloat();

	if( (tmp == NULL) )
	{
		if(params[3] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve float from non-float ANY class"); }
		return -1;
	}
	return amx_ftoc(*tmp);
}

// vector_get_vector(vector:me,slot,Float:vec[3],no_fatal_errors=0)
static cell AMX_NATIVE_CALL	vector_get_vector(AMX *amx,cell *params)
{
	any_vector* tmp_vector = reinterpret_cast<any_vector*>(params[1]);
	HLVector* tmp = (*tmp_vector)[params[2]].getvector();

	if( (tmp == NULL) )
	{
		if(params[4] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve vector from non-vector ANY class"); }
		return -1;
	}
	cell* vec = MF_GetAmxAddr(amx,params[2]);

	vec[0] = amx_ftoc(tmp->x);
	vec[1] = amx_ftoc(tmp->y);
	vec[2] = amx_ftoc(tmp->z);

	return 1;
}

// vector_get_array(vector:me,slot,arr[],len,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	vector_get_array(AMX *amx,cell *params)
{
	any_vector* tmp_vector = reinterpret_cast<any_vector*>(params[1]);
	register vector<cell>* tmp = (*tmp_vector)[params[2]].getarray();

	if( (tmp == NULL) )
	{
		if(params[5] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve array from non-array ANY class"); }
		return -1;
	}
	register cell* arr = MF_GetAmxAddr(amx,params[2]);
	register size_t len = (static_cast<ucell>(params[3]) < tmp->size()) ? (params[3]) : (tmp->size());
	for(register size_t i = 0; i < len; i++)
	{
		arr[i] = (*tmp)[i];
	}

	return len;
}

// vector_get_string(vector:me,slot,arr[],len,no_fatal_errors=0)
static cell AMX_NATIVE_CALL	vector_get_string(AMX *amx,cell *params)
{
	any_vector* tmp_vector = reinterpret_cast<any_vector*>(params[1]);
	register String* tmp = (*tmp_vector)[params[2]].getstring();

	if( (tmp == NULL) )
	{
		if(params[5] == 0) { MF_LogError(amx,AMX_ERR_NATIVE,"Attempted to retrieve string from non-string ANY class"); }
		return -1;
	}

	return MF_SetAmxString(amx,params[2],tmp->c_str(),params[3]);
}


// vector_set(vector:me,slot,Any:ptr)
static cell AMX_NATIVE_CALL	vector_set(AMX *amx,cell *params)
{
	Capsule* tmp = reinterpret_cast<Capsule*>(params[3]);
	(*reinterpret_cast<any_vector*>(params[1]))[params[2]] = *tmp;
	return 1;
}

// vector_set_none(vector:me,slot)
static cell AMX_NATIVE_CALL	vector_set_none(AMX *amx,cell *params)
{
	Capsule tmp; tmp.setnone();
	(*reinterpret_cast<any_vector*>(params[1]))[params[2]] = tmp;
	return 1;
}

// vector_set_bool(vector:me,slot,bool:newval)
static cell AMX_NATIVE_CALL	vector_set_bool(AMX *amx,cell *params)
{
	Capsule tmp; tmp.setbool((params[3] == 1));
	(*reinterpret_cast<any_vector*>(params[1]))[params[2]] = tmp;
	return 1;
}

// vector_set_int(vector:me,slot,cell:newval)
static cell AMX_NATIVE_CALL	vector_set_int(AMX *amx,cell *params)
{
	Capsule tmp; tmp.setint(params[3]);
	(*reinterpret_cast<any_vector*>(params[1]))[params[2]] = tmp;
	return 1;
}

// vector_set_ptr(vector:me,slot,Ptr:newval)
static cell AMX_NATIVE_CALL	vector_set_ptr(AMX *amx,cell *params)
{
	Capsule tmp; tmp.setpointer(reinterpret_cast<void*>(params[3]));
	(*reinterpret_cast<any_vector*>(params[1]))[params[2]] = tmp;
	return 1;
}

// vector_set_float(vector:me,slot,Float:newval)
static cell AMX_NATIVE_CALL	vector_set_float(AMX *amx,cell *params)
{
	Capsule tmp; tmp.setfloat(amx_ctof(params[3]));
	(*reinterpret_cast<any_vector*>(params[1]))[params[2]] = tmp;
	return 1;
}

// vector_set_vector(vector:me,slot,Float:newval[3])
static cell AMX_NATIVE_CALL	vector_set_vector(AMX *amx,cell *params)
{
	cell* ptr = MF_GetAmxAddr(amx,params[3]);
	HLVector tty(amx_ctof(ptr[0]),amx_ctof(ptr[1]),amx_ctof(ptr[2]));

	Capsule tmp; tmp.setvector(tty);
	(*reinterpret_cast<any_vector*>(params[1]))[params[2]] = tmp;
	return 1;
}

// vector_set_array(vector:me,slot,newval[],len)
static cell AMX_NATIVE_CALL	vector_set_array(AMX *amx,cell *params)
{
	cell* ptr = MF_GetAmxAddr(amx,params[3]);
	vector<cell> tty(ptr,params[4]);

	Capsule tmp; tmp.setarray(tty);
	(*reinterpret_cast<any_vector*>(params[1]))[params[2]] = tmp;
	return 1;
}

// vector_set_string(vector:me,slot,newval[])
static cell AMX_NATIVE_CALL	vector_set_string(AMX *amx,cell *params)
{
	int iLen;
	char* ptr = MF_GetAmxString(amx,params[3],0,&iLen);
	String tty(ptr,iLen);

	Capsule tmp; tmp.setstring(tty);
	(*reinterpret_cast<any_vector*>(params[1]))[params[2]] = tmp;
	return 1;
}


AMX_NATIVE_INFO vector_Natives[] =
{
	{"vector_create",		vector_create},
	{"vector_destroy",		vector_destroy},

	{"vector_clear",	vector_clear},
	{"vector_copy",		vector_copy},

	{"vector_comp",		vector_comp},
	{"vector_lex",		vector_lex},

	{"vector_end",		vector_end},
	{"vector_begin",	vector_begin},
	{"vector_at",		vector_at},

	{"vector_rend",		vector_rend},
	{"vector_rbegin",	vector_rbegin},
	{"vector_rat",		vector_rat},

	{"vector_empty",		vector_empty},
	{"vector_size",			vector_size},
	{"vector_memory",		vector_memory},

	{"vector_pop",		vector_pop},

	{"vector_get",			vector_get},
	{"vector_get_raw",		vector_get_raw},
	{"vector_get_bool",		vector_get_bool},
	{"vector_get_int",		vector_get_int},
	{"vector_get_float",	vector_get_float},
	{"vector_get_ptr",		vector_get_ptr},
	{"vector_get_vector",	vector_get_vector},
	{"vector_get_array",	vector_get_array},
	{"vector_get_string",	vector_get_string},

	{"vector_set",				vector_set},
	{"vector_set_none",			vector_set_none},
	{"vector_set_bool",			vector_set_bool},
	{"vector_set_int",			vector_set_int},
	{"vector_set_float",		vector_set_float},
	{"vector_set_ptr",			vector_set_ptr},
	{"vector_set_vector",		vector_set_vector},
	{"vector_set_array",		vector_set_array},
	{"vector_set_string",		vector_set_string},

	{"vector_peek",				vector_peek},
	{"vector_peek_raw",			vector_peek_raw},
	{"vector_peek_bool",		vector_peek_bool},
	{"vector_peek_int",			vector_peek_int},
	{"vector_peek_float",		vector_peek_float},
	{"vector_peek_ptr",			vector_peek_ptr},
	{"vector_peek_vector",		vector_peek_vector},
	{"vector_peek_array",		vector_peek_array},
	{"vector_peek_string",		vector_peek_string},

	{"vector_push",				vector_push},
	{"vector_push_none",		vector_push_none},
	{"vector_push_bool",		vector_push_bool},
	{"vector_push_int",			vector_push_int},
	{"vector_push_float",		vector_push_float},
	{"vector_push_ptr",			vector_push_ptr},
	{"vector_push_vector",		vector_push_vector},
	{"vector_push_array",		vector_push_array},
	{"vector_push_string",		vector_push_string},

	{"vector_front",			vector_front},
	{"vector_front_raw",		vector_front_raw},
	{"vector_front_bool",		vector_front_bool},
	{"vector_front_int",		vector_front_int},
	{"vector_front_float",		vector_front_float},
	{"vector_front_ptr",		vector_front_ptr},
	{"vector_front_vector",		vector_front_vector},
	{"vector_front_array",		vector_front_array},
	{"vector_front_string",		vector_front_string},

	{"vector_back",				vector_back},
	{"vector_back_raw",			vector_back_raw},
	{"vector_back_bool",		vector_back_bool},
	{"vector_back_int",			vector_back_int},
	{"vector_back_float",		vector_back_float},
	{"vector_back_ptr",			vector_back_ptr},
	{"vector_back_vector",		vector_back_vector},
	{"vector_back_array",		vector_back_array},
	{"vector_back_string",		vector_back_string},

	{ NULL,				NULL}
};